/*
 * Souffle - A Datalog Compiler
 * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved
 * Licensed under the Universal Permissive License v 1.0 as shown at:
 * - https://opensource.org/licenses/UPL
 * - <souffle root>/licenses/SOUFFLE-UPL.txt
 */

/************************************************************************
 *
 * @file UnnamedVariable.h
 *
 * Defines the unnamed variable class
 *
 ***********************************************************************/

#pragma once

#include "ast/Argument.h"
#include <ostream>

namespace souffle::ast {

/**
 * @class UnnamedVariable
 * @brief Unnamed variable class
 */
class UnnamedVariable : public Argument {
public:
    using Argument::Argument;

    UnnamedVariable* clone() const override {
        return new UnnamedVariable(getSrcLoc());
    }

protected:
    void print(std::ostream& os) const override {
        os << "_";
    }
};

}  // namespace souffle::ast
