// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.

#line 37 "parser/parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "parser.hh"

// User implementation prologue.

#line 51 "parser/parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 202 "./parser/parser.yy" // lalr1.cc:413

    #include "parser/ParserDriver.h"

#line 57 "parser/parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {
#line 143 "parser/parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (ParserDriver &driver_yyarg, yyscan_t yyscanner_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  parser::~parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
  parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  parser::symbol_number_type
  parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 133: // aggregate_func
        value.move< AggregateOp > (that.value);
        break;

      case 131: // arg
        value.move< Mov<Own<ast::Argument>> > (that.value);
        break;

      case 127: // atom
        value.move< Mov<Own<ast::Atom>> > (that.value);
        break;

      case 113: // attribute
        value.move< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case 107: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (that.value);
        break;

      case 115: // fact
        value.move< Mov<Own<ast::Clause>> > (that.value);
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.move< Mov<Own<ast::Component>> > (that.value);
        break;

      case 141: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case 137: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case 128: // constraint
        value.move< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case 124: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case 142: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case 146: // pragma
        value.move< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case 104: // type
        value.move< Mov<Own<ast::Type>> > (that.value);
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.move< Mov<RuleBody> > (that.value);
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case 118: // head
        value.move< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case 106: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (that.value);
        break;

      case 116: // rule
      case 117: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case 125: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case 103: // identifier
        value.move< Mov<ast::QualifiedName> > (that.value);
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.move< Mov<std::string> > (that.value);
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (that.value);
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case 151: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case 145: // predefined_type
        value.move< TypeAttribute > (that.value);
        break;

      case 148: // directive_head_decl
        value.move< ast::DirectiveType > (that.value);
        break;

      case 114: // relation_tags
        value.move< std::set<RelationTag> > (that.value);
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 133: // aggregate_func
        value.copy< AggregateOp > (that.value);
        break;

      case 131: // arg
        value.copy< Mov<Own<ast::Argument>> > (that.value);
        break;

      case 127: // atom
        value.copy< Mov<Own<ast::Atom>> > (that.value);
        break;

      case 113: // attribute
        value.copy< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case 107: // sum_branch
        value.copy< Mov<Own<ast::BranchDeclaration>> > (that.value);
        break;

      case 115: // fact
        value.copy< Mov<Own<ast::Clause>> > (that.value);
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.copy< Mov<Own<ast::Component>> > (that.value);
        break;

      case 141: // comp_init
        value.copy< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case 137: // comp_type
        value.copy< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case 128: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case 124: // exec_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case 142: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case 146: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case 104: // type
        value.copy< Mov<Own<ast::Type>> > (that.value);
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.copy< Mov<RuleBody> > (that.value);
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case 118: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.copy< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case 106: // sum_branch_list
        value.copy< Mov<VecOwn<ast::BranchDeclaration>> > (that.value);
        break;

      case 116: // rule
      case 117: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.copy< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case 125: // non_empty_exec_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case 103: // identifier
        value.copy< Mov<ast::QualifiedName> > (that.value);
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.copy< Mov<std::string> > (that.value);
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.copy< Mov<std::vector<TypeAttribute>> > (that.value);
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case 151: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case 145: // predefined_type
        value.copy< TypeAttribute > (that.value);
        break;

      case 148: // directive_head_decl
        value.copy< ast::DirectiveType > (that.value);
        break;

      case 114: // relation_tags
        value.copy< std::set<RelationTag> > (that.value);
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 133: // aggregate_func
        yylhs.value.build< AggregateOp > ();
        break;

      case 131: // arg
        yylhs.value.build< Mov<Own<ast::Argument>> > ();
        break;

      case 127: // atom
        yylhs.value.build< Mov<Own<ast::Atom>> > ();
        break;

      case 113: // attribute
        yylhs.value.build< Mov<Own<ast::Attribute>> > ();
        break;

      case 107: // sum_branch
        yylhs.value.build< Mov<Own<ast::BranchDeclaration>> > ();
        break;

      case 115: // fact
        yylhs.value.build< Mov<Own<ast::Clause>> > ();
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        yylhs.value.build< Mov<Own<ast::Component>> > ();
        break;

      case 141: // comp_init
        yylhs.value.build< Mov<Own<ast::ComponentInit>> > ();
        break;

      case 137: // comp_type
        yylhs.value.build< Mov<Own<ast::ComponentType>> > ();
        break;

      case 128: // constraint
        yylhs.value.build< Mov<Own<ast::Constraint>> > ();
        break;

      case 124: // exec_order
        yylhs.value.build< Mov<Own<ast::ExecutionOrder>> > ();
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        yylhs.value.build< Mov<Own<ast::ExecutionPlan>> > ();
        break;

      case 142: // functor_decl
        yylhs.value.build< Mov<Own<ast::FunctorDeclaration>> > ();
        break;

      case 146: // pragma
        yylhs.value.build< Mov<Own<ast::Pragma>> > ();
        break;

      case 104: // type
        yylhs.value.build< Mov<Own<ast::Type>> > ();
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        yylhs.value.build< Mov<RuleBody> > ();
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        yylhs.value.build< Mov<VecOwn<ast::Argument>> > ();
        break;

      case 118: // head
        yylhs.value.build< Mov<VecOwn<ast::Atom>> > ();
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        yylhs.value.build< Mov<VecOwn<ast::Attribute>> > ();
        break;

      case 106: // sum_branch_list
        yylhs.value.build< Mov<VecOwn<ast::BranchDeclaration>> > ();
        break;

      case 116: // rule
      case 117: // rule_def
        yylhs.value.build< Mov<VecOwn<ast::Clause>> > ();
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        yylhs.value.build< Mov<VecOwn<ast::Directive>> > ();
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        yylhs.value.build< Mov<VecOwn<ast::Relation>> > ();
        break;

      case 125: // non_empty_exec_order_list
        yylhs.value.build< Mov<ast::ExecutionOrder::ExecOrder> > ();
        break;

      case 103: // identifier
        yylhs.value.build< Mov<ast::QualifiedName> > ();
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        yylhs.value.build< Mov<std::string> > ();
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        yylhs.value.build< Mov<std::vector<TypeAttribute>> > ();
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        yylhs.value.build< Mov<std::vector<ast::QualifiedName>> > ();
        break;

      case 151: // non_empty_key_value_pairs
        yylhs.value.build< Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
        break;

      case 145: // predefined_type
        yylhs.value.build< TypeAttribute > ();
        break;

      case 148: // directive_head_decl
        yylhs.value.build< ast::DirectiveType > ();
        break;

      case 114: // relation_tags
        yylhs.value.build< std::set<RelationTag> > ();
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 3:
#line 386 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 984 "parser/parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 387 "./parser/parser.yy" // lalr1.cc:859
    { for (auto&& cur : yystack_[0].value.as< Mov<VecOwn<ast::Directive>> > ()) driver.addDirective(std::move(cur)); }
#line 990 "parser/parser.cc" // lalr1.cc:859
    break;

  case 5:
#line 388 "./parser/parser.yy" // lalr1.cc:859
    { for (auto&& cur : yystack_[0].value.as< Mov<VecOwn<ast::Clause>> > ()   ) driver.addClause(std::move(cur)); }
#line 996 "parser/parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 389 "./parser/parser.yy" // lalr1.cc:859
    { driver.addClause            (yystack_[0].value.as< Mov<Own<ast::Clause>> > ()); }
#line 1002 "parser/parser.cc" // lalr1.cc:859
    break;

  case 7:
#line 390 "./parser/parser.yy" // lalr1.cc:859
    { driver.addComponent         (yystack_[0].value.as< Mov<Own<ast::Component>> > ()); }
#line 1008 "parser/parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 391 "./parser/parser.yy" // lalr1.cc:859
    { driver.addInstantiation     (yystack_[0].value.as< Mov<Own<ast::ComponentInit>> > ()); }
#line 1014 "parser/parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 392 "./parser/parser.yy" // lalr1.cc:859
    { driver.addPragma            (yystack_[0].value.as< Mov<Own<ast::Pragma>> > ()); }
#line 1020 "parser/parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 393 "./parser/parser.yy" // lalr1.cc:859
    { driver.addType              (yystack_[0].value.as< Mov<Own<ast::Type>> > ()); }
#line 1026 "parser/parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 394 "./parser/parser.yy" // lalr1.cc:859
    { driver.addFunctorDeclaration(yystack_[0].value.as< Mov<Own<ast::FunctorDeclaration>> > ()); }
#line 1032 "parser/parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 395 "./parser/parser.yy" // lalr1.cc:859
    {
        for (auto&& rel : yystack_[0].value.as< Mov<VecOwn<ast::Relation>> > ()) {
            driver.addIoFromDeprecatedTag(*rel);
            driver.addRelation(std::move(rel));
        }
    }
#line 1043 "parser/parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 408 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<ast::QualifiedName> > () = yystack_[0].value.as< std::string > (); }
#line 1049 "parser/parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 410 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<ast::QualifiedName> > () = yystack_[2].value.as< Mov<ast::QualifiedName> > (); yylhs.value.as< Mov<ast::QualifiedName> > ()->append(yystack_[0].value.as< std::string > ()); }
#line 1055 "parser/parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 419 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = mk<ast::SubsetType>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1061 "parser/parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 420 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = mk<ast::UnionType>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<std::vector<ast::QualifiedName>> > (), yylhs.location); }
#line 1067 "parser/parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 421 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = mk<ast::RecordType>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<VecOwn<ast::Attribute>> > (), yylhs.location); }
#line 1073 "parser/parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 422 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = mk<ast::AlgebraicDataType>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<VecOwn<ast::BranchDeclaration>> > (), yylhs.location); }
#line 1079 "parser/parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 424 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as< std::string > (), "number", yylhs.location); }
#line 1085 "parser/parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 425 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as< std::string > (), "symbol", yylhs.location); }
#line 1091 "parser/parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 426 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as< std::string > (), "symbol", yylhs.location); }
#line 1097 "parser/parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 431 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as< Mov<ast::QualifiedName> > ()); }
#line 1103 "parser/parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 432 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as< Mov<std::vector<ast::QualifiedName>> > (); yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as< Mov<ast::QualifiedName> > ()); }
#line 1109 "parser/parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 436 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<VecOwn<ast::BranchDeclaration>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::BranchDeclaration>> > ()); }
#line 1115 "parser/parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 437 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::BranchDeclaration>> > () = yystack_[2].value.as< Mov<VecOwn<ast::BranchDeclaration>> > (); yylhs.value.as< Mov<VecOwn<ast::BranchDeclaration>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::BranchDeclaration>> > ()); }
#line 1121 "parser/parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 442 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::BranchDeclaration>> > () = mk<ast::BranchDeclaration>(yystack_[2].value.as< std::string > (), VecOwn<ast::Attribute>{}, yylhs.location); }
#line 1127 "parser/parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 444 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::BranchDeclaration>> > () = mk<ast::BranchDeclaration>(yystack_[3].value.as< std::string > (), yystack_[1].value.as< Mov<VecOwn<ast::Attribute>> > (), yylhs.location); }
#line 1133 "parser/parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 453 "./parser/parser.yy" // lalr1.cc:859
    {
        auto tags             = yystack_[0].value.as< std::set<RelationTag> > ();
        auto attributes_list  = yystack_[1].value.as< Mov<VecOwn<ast::Attribute>> > ();

        yylhs.value.as< Mov<VecOwn<ast::Relation>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Relation>> > ();
        for (auto&& rel : yylhs.value.as< Mov<VecOwn<ast::Relation>> > ()) {
            for (auto tag : tags) {
                if (isRelationQualifierTag(tag)) {
                    rel->addQualifier(getRelationQualifierFromTag(tag));
                } else if (isRelationRepresentationTag(tag)) {
                    rel->setRepresentation(getRelationRepresentationFromTag(tag));
                } else {
                    assert(false && "unhandled tag");
                }
            }

            rel->setAttributes(clone(attributes_list));
        }
    }
#line 1157 "parser/parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 476 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as< std::string > (), yystack_[0].location)); }
#line 1163 "parser/parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 477 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Relation>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Relation>> > (); yylhs.value.as< Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as< std::string > (), yystack_[0].location)); }
#line 1169 "parser/parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 483 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 1175 "parser/parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 484 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as< Mov<VecOwn<ast::Attribute>> > (); }
#line 1181 "parser/parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 488 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 1187 "parser/parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 489 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as< Mov<VecOwn<ast::Attribute>> > (); }
#line 1193 "parser/parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 493 "./parser/parser.yy" // lalr1.cc:859
    {           yylhs.value.as< Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Attribute>> > ()); }
#line 1199 "parser/parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 494 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Attribute>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Attribute>> > ();  yylhs.value.as< Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Attribute>> > ()); }
#line 1205 "parser/parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 498 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Attribute>> > () = mk<ast::Attribute>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<ast::QualifiedName> > (), yystack_[0].location); }
#line 1211 "parser/parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 503 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 1217 "parser/parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 505 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::OUTPUT, yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1223 "parser/parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 507 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::INPUT, yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1229 "parser/parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 509 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::PRINTSIZE, yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1235 "parser/parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 510 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addTag(RelationTag::OVERRIDABLE , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1241 "parser/parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 511 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addTag(RelationTag::INLINE      , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1247 "parser/parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 512 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addTag(RelationTag::MAGIC       , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1253 "parser/parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 513 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addReprTag(RelationTag::BRIE    , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1259 "parser/parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 514 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addReprTag(RelationTag::BTREE   , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1265 "parser/parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 515 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< std::set<RelationTag> > () = driver.addReprTag(RelationTag::EQREL   , yystack_[0].location, yystack_[1].value.as< std::set<RelationTag> > ()); }
#line 1271 "parser/parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 523 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Clause>> > () = mk<ast::Clause>(yystack_[1].value.as< Mov<Own<ast::Atom>> > (), Mov<VecOwn<ast::Literal>> {}, nullptr, yylhs.location); }
#line 1277 "parser/parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 527 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<VecOwn<ast::Clause>> > () = yystack_[0].value.as< Mov<VecOwn<ast::Clause>> > ();
    }
#line 1285 "parser/parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 530 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<VecOwn<ast::Clause>> > () = yystack_[1].value.as< Mov<VecOwn<ast::Clause>> > ();
        auto exec_plan = yystack_[0].value.as< Mov<Own<ast::ExecutionPlan>> > ();
        for (auto&& rule : yylhs.value.as< Mov<VecOwn<ast::Clause>> > ()) {
            rule->setExecutionPlan(clone(exec_plan));
        }
    }
#line 1297 "parser/parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 541 "./parser/parser.yy" // lalr1.cc:859
    {
        auto bodies = yystack_[1].value.as< Mov<RuleBody> > ()->toClauseBodies();

        for (auto&& head : yystack_[3].value.as< Mov<VecOwn<ast::Atom>> > ()) {
            for (auto&& body : bodies) {
                auto cur = clone(body);
                cur->setHead(clone(head));
                cur->setSrcLoc(yylhs.location);
                yylhs.value.as< Mov<VecOwn<ast::Clause>> > ().push_back(std::move(cur));
            }
        }
    }
#line 1314 "parser/parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 557 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Atom>> > ()); }
#line 1320 "parser/parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 558 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Atom>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Atom>> > (); yylhs.value.as< Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Atom>> > ()); }
#line 1326 "parser/parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 562 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[0].value.as< Mov<RuleBody> > (); }
#line 1332 "parser/parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 565 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[0].value.as< Mov<RuleBody> > (); }
#line 1338 "parser/parser.cc" // lalr1.cc:859
    break;

  case 56:
#line 566 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[2].value.as< Mov<RuleBody> > (); yylhs.value.as< Mov<RuleBody> > ()->disjunct(yystack_[0].value.as< Mov<RuleBody> > ()); }
#line 1344 "parser/parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 570 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[0].value.as< Mov<RuleBody> > (); }
#line 1350 "parser/parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 571 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[2].value.as< Mov<RuleBody> > (); yylhs.value.as< Mov<RuleBody> > ()->conjunct(yystack_[0].value.as< Mov<RuleBody> > ()); }
#line 1356 "parser/parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 575 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::ExecutionPlan>> > () = yystack_[0].value.as< Mov<Own<ast::ExecutionPlan>> > (); }
#line 1362 "parser/parser.cc" // lalr1.cc:859
    break;

  case 60:
#line 579 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<Own<ast::ExecutionPlan>> > () = mk<ast::ExecutionPlan>();
        yylhs.value.as< Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as< std::string > ()), Own<ast::ExecutionOrder>(yystack_[0].value.as< Mov<Own<ast::ExecutionOrder>> > ()));
    }
#line 1371 "parser/parser.cc" // lalr1.cc:859
    break;

  case 61:
#line 583 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<Own<ast::ExecutionPlan>> > () = yystack_[4].value.as< Mov<Own<ast::ExecutionPlan>> > ();
        yylhs.value.as< Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as< std::string > ()), yystack_[0].value.as< Mov<Own<ast::ExecutionOrder>> > ());
    }
#line 1380 "parser/parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 591 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(ast::ExecutionOrder::ExecOrder(), yylhs.location); }
#line 1386 "parser/parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 592 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(yystack_[1].value.as< Mov<ast::ExecutionOrder::ExecOrder> > (), yylhs.location); }
#line 1392 "parser/parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 595 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as< std::string > ())); }
#line 1398 "parser/parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 596 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<ast::ExecutionOrder::ExecOrder> > () = yystack_[2].value.as< Mov<ast::ExecutionOrder::ExecOrder> > (); yylhs.value.as< Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as< std::string > ())); }
#line 1404 "parser/parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 605 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as< Mov<Own<ast::Atom>> > ()); }
#line 1410 "parser/parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 606 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = RuleBody::constraint(yystack_[0].value.as< Mov<Own<ast::Constraint>> > ()); }
#line 1416 "parser/parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 607 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[1].value.as< Mov<RuleBody> > (); }
#line 1422 "parser/parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 608 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[0].value.as< Mov<RuleBody> > ()->negated(); }
#line 1428 "parser/parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 612 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Atom>> > () = mk<ast::Atom>(yystack_[3].value.as< Mov<ast::QualifiedName> > (), yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1434 "parser/parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 617 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LT, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1440 "parser/parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 618 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GT, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1446 "parser/parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 619 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LE, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1452 "parser/parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 620 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GE, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1458 "parser/parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 621 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::EQ, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1464 "parser/parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 622 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::NE, yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1470 "parser/parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 626 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::MATCH   , yystack_[3].value.as< Mov<Own<ast::Argument>> > (), yystack_[1].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1476 "parser/parser.cc" // lalr1.cc:859
    break;

  case 78:
#line 628 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::CONTAINS, yystack_[3].value.as< Mov<Own<ast::Argument>> > (), yystack_[1].value.as< Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1482 "parser/parser.cc" // lalr1.cc:859
    break;

  case 79:
#line 631 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(true , yylhs.location); }
#line 1488 "parser/parser.cc" // lalr1.cc:859
    break;

  case 80:
#line 632 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(false, yylhs.location); }
#line 1494 "parser/parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 636 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 1500 "parser/parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 636 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Argument>> > () = yystack_[0].value.as< Mov<VecOwn<ast::Argument>> > (); }
#line 1506 "parser/parser.cc" // lalr1.cc:859
    break;

  case 83:
#line 638 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1512 "parser/parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 639 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Argument>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Argument>> > (); yylhs.value.as< Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1518 "parser/parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 644 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::StringConstant >(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1524 "parser/parser.cc" // lalr1.cc:859
    break;

  case 86:
#line 645 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as< std::string > (), ast::NumericConstant::Type::Float, yylhs.location); }
#line 1530 "parser/parser.cc" // lalr1.cc:859
    break;

  case 87:
#line 646 "./parser/parser.yy" // lalr1.cc:859
    {
      auto&& n = yystack_[0].value.as< std::string > (); // drop the last character (`u`)
      yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(n.substr(0, n.size() - 1), ast::NumericConstant::Type::Uint, yylhs.location);
    }
#line 1539 "parser/parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 650 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1545 "parser/parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 651 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location); }
#line 1551 "parser/parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 652 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::Counter        >(yylhs.location); }
#line 1557 "parser/parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 653 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::Variable       >(yystack_[0].value.as< std::string > (), yylhs.location); }
#line 1563 "parser/parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 654 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::NilConstant    >(yylhs.location); }
#line 1569 "parser/parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 657 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::RecordInit>(yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1575 "parser/parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 660 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::BranchInit>(yystack_[3].value.as< std::string > (), yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1581 "parser/parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 661 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::BranchInit>(yystack_[0].value.as< std::string > (), VecOwn<ast::Argument>{}, yylhs.location); }
#line 1587 "parser/parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 663 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = yystack_[1].value.as< Mov<Own<ast::Argument>> > (); }
#line 1593 "parser/parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 664 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::TypeCast>(yystack_[3].value.as< Mov<Own<ast::Argument>> > (), yystack_[1].value.as< Mov<ast::QualifiedName> > (), yylhs.location); }
#line 1599 "parser/parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 666 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::UserDefinedFunctor>(yystack_[3].value.as< std::string > (), *yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1605 "parser/parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 667 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yystack_[3].value.as< Mov<std::string> > (), *yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1611 "parser/parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 670 "./parser/parser.yy" // lalr1.cc:859
    {
        VecOwn<ast::Argument> arg_list = yystack_[1].value.as< Mov<VecOwn<ast::Argument>> > ();
        arg_list.insert(arg_list.begin(), yystack_[3].value.as< Mov<Own<ast::Argument>> > ());

        auto agg_2_func = [](AggregateOp op) -> char const* {
          switch (op) {
            case AggregateOp::COUNT : return {};
            case AggregateOp::MAX   : return "max";
            case AggregateOp::MEAN  : return {};
            case AggregateOp::MIN   : return "min";
            case AggregateOp::SUM   : return {};
            default                 :
              fatal("missing base op handler, or got an overload op?");
          }
        };

        if (auto* func_op = agg_2_func(yystack_[5].value.as< AggregateOp > ())) {
          yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(func_op, std::move(arg_list), yylhs.location);
        } else {
          driver.error(yylhs.location, "aggregate operation has no functor equivalent");
          yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location);
        }
    }
#line 1639 "parser/parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 696 "./parser/parser.yy" // lalr1.cc:859
    {
        // If we have a constant that is not already negated we just negate the constant value.
        auto nested_arg = *yystack_[0].value.as< Mov<Own<ast::Argument>> > ();
        const auto* asNumeric = dynamic_cast<const ast::NumericConstant*>(&*nested_arg);
        if (asNumeric && !isPrefix("-", asNumeric->getConstant())) {
            yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>("-" + asNumeric->getConstant(), asNumeric->getType(), yystack_[0].location);
        } else { // Otherwise, create a functor.
            yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, FUNCTOR_INTRINSIC_PREFIX_NEGATE_NAME, std::move(nested_arg));
        }
    }
#line 1654 "parser/parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 706 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "~", yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1660 "parser/parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 707 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "!", yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1666 "parser/parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 710 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "+"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1672 "parser/parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 711 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "-"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1678 "parser/parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 712 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "*"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1684 "parser/parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 713 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "/"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1690 "parser/parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 714 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "%"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1696 "parser/parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 715 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "**" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1702 "parser/parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 716 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&&" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1708 "parser/parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 717 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "||" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1714 "parser/parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 718 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^^" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1720 "parser/parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 719 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1726 "parser/parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 720 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "|"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1732 "parser/parser.cc" // lalr1.cc:859
    break;

  case 115:
#line 721 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^"  , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1738 "parser/parser.cc" // lalr1.cc:859
    break;

  case 116:
#line 722 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "<<" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1744 "parser/parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 723 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>" , yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1750 "parser/parser.cc" // lalr1.cc:859
    break;

  case 118:
#line 724 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>>", yystack_[2].value.as< Mov<Own<ast::Argument>> > (), yystack_[0].value.as< Mov<Own<ast::Argument>> > ()); }
#line 1756 "parser/parser.cc" // lalr1.cc:859
    break;

  case 119:
#line 727 "./parser/parser.yy" // lalr1.cc:859
    {
        auto bodies = yystack_[0].value.as< Mov<RuleBody> > ()->toClauseBodies();
        if (bodies.size() != 1) {
            driver.error("ERROR: disjunctions in aggregation clauses are currently not supported");
        }

        // TODO: move this to a semantic check when aggs are extended to multiple exprs
        auto given    = yystack_[2].value.as< Mov<VecOwn<ast::Argument>> > ().size();
        auto required = aggregateArity(yystack_[3].value.as< AggregateOp > ());
        if (given < required.first || required.second < given) {
            driver.error("ERROR: incorrect expression arity for given aggregate mode");
        }

        auto expr = yystack_[2].value.as< Mov<VecOwn<ast::Argument>> > ().empty() ? nullptr : std::move(yystack_[2].value.as< Mov<VecOwn<ast::Argument>> > ()[0]);
        auto body = (bodies.size() == 1) ? clone(bodies[0]->getBodyLiterals()) : VecOwn<ast::Literal> {};
        yylhs.value.as< Mov<Own<ast::Argument>> > () = mk<ast::Aggregator>(yystack_[3].value.as< AggregateOp > (), std::move(expr), std::move(body), yylhs.location);
    }
#line 1778 "parser/parser.cc" // lalr1.cc:859
    break;

  case 120:
#line 747 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "cat";         }
#line 1784 "parser/parser.cc" // lalr1.cc:859
    break;

  case 121:
#line 748 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "ord";         }
#line 1790 "parser/parser.cc" // lalr1.cc:859
    break;

  case 122:
#line 749 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "range";       }
#line 1796 "parser/parser.cc" // lalr1.cc:859
    break;

  case 123:
#line 750 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "strlen";      }
#line 1802 "parser/parser.cc" // lalr1.cc:859
    break;

  case 124:
#line 751 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "substr";      }
#line 1808 "parser/parser.cc" // lalr1.cc:859
    break;

  case 125:
#line 752 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "to_float";    }
#line 1814 "parser/parser.cc" // lalr1.cc:859
    break;

  case 126:
#line 753 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "to_number";   }
#line 1820 "parser/parser.cc" // lalr1.cc:859
    break;

  case 127:
#line 754 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "to_string";   }
#line 1826 "parser/parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 755 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "to_unsigned"; }
#line 1832 "parser/parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 759 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< AggregateOp > () = AggregateOp::COUNT;  }
#line 1838 "parser/parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 760 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< AggregateOp > () = AggregateOp::MAX;    }
#line 1844 "parser/parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 761 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< AggregateOp > () = AggregateOp::MEAN;   }
#line 1850 "parser/parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 762 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< AggregateOp > () = AggregateOp::MIN;    }
#line 1856 "parser/parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 763 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< AggregateOp > () = AggregateOp::SUM;    }
#line 1862 "parser/parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 767 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = yystack_[1].value.as< Mov<RuleBody> > (); }
#line 1868 "parser/parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 768 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as< Mov<Own<ast::Atom>> > ()); }
#line 1874 "parser/parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 777 "./parser/parser.yy" // lalr1.cc:859
    {
        auto head = yystack_[3].value.as< Mov<Own<ast::Component>> > ();
        yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > ();
        yylhs.value.as< Mov<Own<ast::Component>> > ()->setComponentType(clone(head->getComponentType()));
        yylhs.value.as< Mov<Own<ast::Component>> > ()->copyBaseComponents(**head);
        yylhs.value.as< Mov<Own<ast::Component>> > ()->setSrcLoc(yylhs.location);
    }
#line 1886 "parser/parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 788 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = mk<ast::Component>();  yylhs.value.as< Mov<Own<ast::Component>> > ()->setComponentType(yystack_[0].value.as< Mov<Own<ast::ComponentType>> > ()); }
#line 1892 "parser/parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 789 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[2].value.as< Mov<Own<ast::Component>> > ();                  yylhs.value.as< Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as< Mov<Own<ast::ComponentType>> > ()); }
#line 1898 "parser/parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 790 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[2].value.as< Mov<Own<ast::Component>> > ();                  yylhs.value.as< Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as< Mov<Own<ast::ComponentType>> > ()); }
#line 1904 "parser/parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 794 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::ComponentType>> > () = mk<ast::ComponentType>(yystack_[1].value.as< std::string > (), yystack_[0].value.as< Mov<std::vector<ast::QualifiedName>> > (), yylhs.location); }
#line 1910 "parser/parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 798 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 1916 "parser/parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 799 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > () = yystack_[1].value.as< Mov<std::vector<ast::QualifiedName>> > (); }
#line 1922 "parser/parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 804 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as< std::string > ()); }
#line 1928 "parser/parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 805 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as< Mov<std::vector<ast::QualifiedName>> > (); yylhs.value.as< Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as< std::string > ()); }
#line 1934 "parser/parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 810 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = mk<ast::Component>(); }
#line 1940 "parser/parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 811 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); for (auto&& x : yystack_[0].value.as< Mov<VecOwn<ast::Directive>> > ()) yylhs.value.as< Mov<Own<ast::Component>> > ()->addDirective(std::move(x)); }
#line 1946 "parser/parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 812 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); for (auto&& x : yystack_[0].value.as< Mov<VecOwn<ast::Clause>> > ()) yylhs.value.as< Mov<Own<ast::Component>> > ()->addClause(std::move(x)); }
#line 1952 "parser/parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 813 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); yylhs.value.as< Mov<Own<ast::Component>> > ()->addClause       (yystack_[0].value.as< Mov<Own<ast::Clause>> > ()); }
#line 1958 "parser/parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 814 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[2].value.as< Mov<Own<ast::Component>> > (); yylhs.value.as< Mov<Own<ast::Component>> > ()->addOverride     (yystack_[0].value.as< std::string > ()); }
#line 1964 "parser/parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 815 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); yylhs.value.as< Mov<Own<ast::Component>> > ()->addInstantiation(yystack_[0].value.as< Mov<Own<ast::ComponentInit>> > ()); }
#line 1970 "parser/parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 816 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); yylhs.value.as< Mov<Own<ast::Component>> > ()->addComponent    (yystack_[0].value.as< Mov<Own<ast::Component>> > ()); }
#line 1976 "parser/parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 817 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > (); yylhs.value.as< Mov<Own<ast::Component>> > ()->addType         (yystack_[0].value.as< Mov<Own<ast::Type>> > ()); }
#line 1982 "parser/parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 818 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<Own<ast::Component>> > () = yystack_[1].value.as< Mov<Own<ast::Component>> > ();
        for (auto&& rel : yystack_[0].value.as< Mov<VecOwn<ast::Relation>> > ()) {
            driver.addIoFromDeprecatedTag(*rel);
            yylhs.value.as< Mov<Own<ast::Component>> > ()->addRelation(std::move(rel));
        }
    }
#line 1994 "parser/parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 828 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::ComponentInit>> > () = mk<ast::ComponentInit>(yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<Own<ast::ComponentType>> > (), yylhs.location); }
#line 2000 "parser/parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 837 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[5].value.as< std::string > (), yystack_[3].value.as< Mov<std::vector<TypeAttribute>> > (), yystack_[0].value.as< TypeAttribute > (), false, yylhs.location); }
#line 2006 "parser/parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 839 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[6].value.as< std::string > (), yystack_[4].value.as< Mov<std::vector<TypeAttribute>> > (), yystack_[1].value.as< TypeAttribute > (), true, yylhs.location); }
#line 2012 "parser/parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 843 "./parser/parser.yy" // lalr1.cc:859
    { }
#line 2018 "parser/parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 843 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<TypeAttribute>> > () = yystack_[0].value.as< Mov<std::vector<TypeAttribute>> > (); }
#line 2024 "parser/parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 845 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<std::vector<TypeAttribute>> > ().push_back(yystack_[0].value.as< TypeAttribute > ()); }
#line 2030 "parser/parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 846 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<TypeAttribute>> > () = yystack_[2].value.as< Mov<std::vector<TypeAttribute>> > (); yylhs.value.as< Mov<std::vector<TypeAttribute>> > ().push_back(yystack_[0].value.as< TypeAttribute > ()); }
#line 2036 "parser/parser.cc" // lalr1.cc:859
    break;

  case 161:
#line 851 "./parser/parser.yy" // lalr1.cc:859
    {
        if (yystack_[0].value.as< std::string > () == "number") {
            yylhs.value.as< TypeAttribute > () = TypeAttribute::Signed;
        } else if (yystack_[0].value.as< std::string > () == "symbol") {
            yylhs.value.as< TypeAttribute > () = TypeAttribute::Symbol;
        } else if (yystack_[0].value.as< std::string > () == "float") {
            yylhs.value.as< TypeAttribute > () = TypeAttribute::Float;
        } else if (yystack_[0].value.as< std::string > () == "unsigned") {
            yylhs.value.as< TypeAttribute > () = TypeAttribute::Unsigned;
        } else {
            driver.error(yystack_[0].location, "[number | symbol | float | unsigned] identifier expected");
        }
    }
#line 2054 "parser/parser.cc" // lalr1.cc:859
    break;

  case 162:
#line 872 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[1].value.as< std::string > ()   , yystack_[0].value.as< std::string > (), yylhs.location); }
#line 2060 "parser/parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 873 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[0].value.as< std::string > (), ""    , yylhs.location); }
#line 2066 "parser/parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 878 "./parser/parser.yy" // lalr1.cc:859
    {
        auto directive_head_decl = yystack_[1].value.as< ast::DirectiveType > ();
        for (auto&& io : yystack_[0].value.as< Mov<VecOwn<ast::Directive>> > ()) {
            io->setType(directive_head_decl);
            yylhs.value.as< Mov<VecOwn<ast::Directive>> > ().push_back(std::move(io));
        }
    }
#line 2078 "parser/parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 888 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::DirectiveType > () = ast::DirectiveType::input;      }
#line 2084 "parser/parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 889 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::DirectiveType > () = ast::DirectiveType::output;     }
#line 2090 "parser/parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 890 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::DirectiveType > () = ast::DirectiveType::printsize;  }
#line 2096 "parser/parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 891 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< ast::DirectiveType > () = ast::DirectiveType::limitsize;  }
#line 2102 "parser/parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 896 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Directive>> > () = yystack_[0].value.as< Mov<VecOwn<ast::Directive>> > (); }
#line 2108 "parser/parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 897 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Directive>> > (); }
#line 2114 "parser/parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 898 "./parser/parser.yy" // lalr1.cc:859
    {
        yylhs.value.as< Mov<VecOwn<ast::Directive>> > () = yystack_[3].value.as< Mov<VecOwn<ast::Directive>> > ();
        for (auto&& kvp : yystack_[1].value.as< Mov<std::vector<std::pair
            <std::string, std::string>>> > ()) {
            for (auto&& io : yylhs.value.as< Mov<VecOwn<ast::Directive>> > ()) {
                io->addParameter(kvp.first, kvp.second);
            }
        }
    }
#line 2128 "parser/parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 911 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as< Mov<ast::QualifiedName> > (), yystack_[0].location)); }
#line 2134 "parser/parser.cc" // lalr1.cc:859
    break;

  case 173:
#line 912 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as< Mov<VecOwn<ast::Directive>> > (); yylhs.value.as< Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as< Mov<ast::QualifiedName> > (), yystack_[0].location)); }
#line 2140 "parser/parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 917 "./parser/parser.yy" // lalr1.cc:859
    {          yylhs.value.as< Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({ yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<std::string> > () }); }
#line 2147 "parser/parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 918 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::vector<std::pair
            <std::string, std::string>>> > () = yystack_[4].value.as< Mov<std::vector<std::pair
            <std::string, std::string>>> > (); yylhs.value.as< Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({ yystack_[2].value.as< std::string > (), yystack_[0].value.as< Mov<std::string> > () }); }
#line 2156 "parser/parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 921 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = yystack_[0].value.as< std::string > (); }
#line 2162 "parser/parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 922 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = yystack_[0].value.as< std::string > (); }
#line 2168 "parser/parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 923 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = yystack_[0].value.as< std::string > (); }
#line 2174 "parser/parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 924 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "true"; }
#line 2180 "parser/parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 925 "./parser/parser.yy" // lalr1.cc:859
    { yylhs.value.as< Mov<std::string> > () = "false"; }
#line 2186 "parser/parser.cc" // lalr1.cc:859
    break;


#line 2190 "parser/parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int parser::yypact_ninf_ = -198;

  const signed char parser::yytable_ninf_ = -14;

  const short int
  parser::yypact_[] =
  {
    -198,    22,    58,  -198,  -198,    27,    21,    75,  -198,  -198,
    -198,  -198,    85,    95,   102,   103,   105,    12,  -198,  -198,
    -198,  -198,    10,   -25,    71,  -198,   -47,  -198,  -198,  -198,
    -198,   142,   169,  -198,   -26,   117,    -4,   104,  -198,   113,
    -198,  -198,   235,   185,   186,  -198,   152,   142,  -198,    95,
      95,  -198,   116,  -198,    -3,  -198,     3,   188,  -198,   189,
       9,   190,   191,  -198,    95,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,  -198,  -198,   128,   193,  -198,   235,  -198,   194,
     235,   235,   235,   235,   134,   135,   634,   136,   313,  -198,
     137,   144,    17,   138,   139,  -198,  -198,   152,   152,   143,
     148,   153,  -198,  -198,  -198,   370,  -198,  -198,  -198,    11,
       4,   142,   141,  -198,    18,  -198,  -198,   151,  -198,   155,
     156,  -198,   145,     7,   116,   162,   167,  -198,  -198,  -198,
    -198,   -53,  -198,   235,   160,   168,   161,   154,   436,   154,
     154,  -198,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     163,   165,   226,   235,   235,  -198,    39,   337,  -198,   152,
     152,   235,   235,   235,   235,   235,   235,   231,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198,   170,  -198,    48,   116,
     142,  -198,   232,  -198,  -198,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,   166,   189,     2,  -198,   -44,   142,   244,   245,
    -198,   469,   235,  -198,   235,  -198,   634,    37,    37,   154,
     154,   154,   154,   741,   737,   317,   -38,   -38,   -38,   708,
     667,   700,   182,   403,     1,     5,  -198,   181,   502,   535,
    -198,   153,  -198,   634,   634,   634,   634,   634,   634,  -198,
      32,  -198,   249,   116,  -198,   189,  -198,  -198,   -49,  -198,
     116,   145,  -198,  -198,   142,   197,   198,  -198,   235,   152,
    -198,  -198,  -198,  -198,    70,   165,   235,   235,  -198,  -198,
    -198,  -198,  -198,  -198,   195,   248,  -198,    36,  -198,  -198,
      74,   192,  -198,   264,  -198,   568,   601,    32,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198
  };

  const unsigned char
  parser::yydefact_[] =
  {
       3,     0,     2,     1,    13,     0,     0,     0,   165,   166,
     167,   168,     0,     0,     0,     0,     0,     0,    10,    12,
       6,     5,    49,     0,    52,     7,     0,     8,    11,     9,
       4,     0,   163,    29,     0,     0,    21,   141,   137,     0,
      19,    20,    81,     0,     0,    50,     0,     0,    48,     0,
       0,   145,   172,   164,   169,   162,     0,     0,    38,   157,
       0,     0,     0,   140,     0,    85,    91,    88,    87,    86,
     120,   121,   122,   123,   124,   131,   132,   130,   129,   133,
     125,   126,   127,   128,     0,     0,    92,    81,    89,    90,
       0,     0,     0,     0,     0,    82,    83,     0,    81,    14,
       0,    59,    91,     0,     0,    79,    80,     0,     0,     0,
      54,    55,    57,    66,    67,     0,    53,   139,   138,     0,
       0,     0,     0,    33,     0,    35,    30,    28,   161,     0,
     158,   159,    13,     0,    22,    16,    18,    24,    17,    15,
     143,     0,   154,     0,     0,     0,    95,   101,     0,   102,
     103,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    81,     0,
       0,     0,     0,     0,     0,    69,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   136,   152,
     153,   148,   147,   151,   150,   146,     0,   170,     0,   173,
       0,    34,     0,    39,    40,    41,    45,    46,    47,    42,
      43,    44,     0,     0,     0,    31,     0,     0,     0,     0,
     142,     0,    81,    93,    81,    96,    84,   104,   105,   106,
     107,   109,   108,   113,   114,   115,   116,   117,   118,   110,
     111,   112,     0,     0,     0,     0,    60,     0,     0,     0,
      68,    56,    58,    75,    71,    72,    73,    74,    76,   149,
       0,   171,     0,    37,    36,     0,   160,    26,     0,    32,
      23,     0,    25,   144,     0,     0,     0,    99,     0,     0,
     135,   119,    64,    62,     0,     0,     0,     0,   176,   177,
     178,   179,   180,   174,     0,   155,    27,     0,    98,    94,
       0,     0,    63,     0,    61,     0,     0,     0,   156,    97,
     100,   134,    65,    77,    78,   175
  };

  const short int
  parser::yypgoto_[] =
  {
    -198,  -198,  -198,   -31,   157,  -198,  -198,    53,   158,  -198,
    -198,  -198,  -130,    72,  -198,   159,   171,  -198,  -198,    -7,
     172,    96,  -198,  -198,    -6,  -198,  -103,     0,  -198,   -86,
       8,   -32,  -198,  -198,  -198,   176,  -198,   -30,  -198,  -198,
    -198,   178,  -198,  -198,  -198,  -197,  -198,   183,  -198,  -198,
    -198,  -198,   -20
  };

  const short int
  parser::yydefgoto_[] =
  {
      -1,     1,     2,    17,    18,   135,   136,   137,    19,    34,
     138,    58,   124,   125,   127,    20,    21,    22,    23,   109,
     110,   111,    45,   101,   246,   284,   112,   113,   114,    94,
      95,    96,    97,    98,   281,    25,    26,    38,    63,   141,
     119,    27,    28,   129,   130,   131,    29,    30,    31,    53,
      54,   198,   293
  };

  const short int
  parser::yytable_[] =
  {
      52,   145,    24,   216,   175,     4,   122,   122,   196,    46,
     282,   122,   170,   132,   115,     4,   266,   219,   269,   117,
     118,   202,     3,    49,    50,    33,   202,   153,   154,   134,
      32,   220,   296,    51,   142,   288,   289,   290,   155,   156,
     157,   158,    56,    44,    57,    47,     6,   116,     8,     9,
      10,    11,   187,    12,    13,    14,    15,    16,   147,   148,
     149,   150,     4,   291,   292,   120,     5,   121,   295,   215,
     133,    60,   123,   197,   283,   115,   177,   252,    61,    35,
      42,   279,   242,   267,   268,   -13,    43,   201,   202,    36,
     199,   -13,   188,     6,     7,     8,     9,    10,    11,    37,
      12,    13,    14,    15,    16,   309,    39,    40,   250,    41,
      43,   221,   179,   155,   156,   157,   158,   261,   262,    24,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   275,   243,   276,   302,
     303,   248,   249,   310,   152,    48,     4,   115,   115,   253,
     254,   255,   256,   257,   258,    65,   102,    67,    68,    69,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   263,
     103,   104,    55,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,   105,   106,    59,   270,    62,    64,    99,
      43,   100,   126,   128,   139,   140,   143,   144,   146,    80,
      81,    82,    83,   151,   168,   152,   173,   174,   171,    84,
      85,    86,   200,    87,   172,    88,    89,   178,    90,   107,
     108,   179,   217,   180,   212,   214,   213,   218,   222,   224,
     223,   247,   157,   245,   244,   259,   122,   265,    65,    66,
      67,    68,    69,   297,   280,   260,    92,   115,   271,   273,
      93,   277,   285,   294,   305,   306,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,   298,   299,   308,   312,
     307,   272,   301,   311,   264,   251,   189,   190,   191,   304,
     176,     0,    80,    81,    82,    83,   300,   315,     0,     0,
     192,     0,    84,    85,    86,   193,    87,   194,    88,    89,
       0,    90,   195,    91,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,    66,    67,    68,
      69,     0,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,     0,    93,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
      84,    85,    86,     0,    87,     0,    88,    89,     0,    90,
       0,   169,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,     0,
       0,     0,   153,   154,     0,   159,   225,    92,   162,   163,
     164,    93,   181,   155,   156,   157,   158,     0,     0,     0,
     182,   183,   184,   185,   186,   159,   160,   161,   162,   163,
     164,     0,   165,   166,   167,   153,   154,     0,     0,     0,
       0,     0,     0,     0,     0,   181,   155,   156,   157,   158,
       0,     0,     0,   182,   183,   184,   185,   186,   159,   160,
     161,   162,   163,   164,     0,   165,   166,   167,   153,   154,
       0,     0,   225,   278,     0,     0,     0,     0,     0,   155,
     156,   157,   158,     0,     0,     0,     0,     0,     0,     0,
       0,   159,   160,   161,   162,   163,   164,     0,   165,   166,
     167,   153,   154,     0,     0,   225,     0,     0,     0,     0,
       0,     0,   155,   156,   157,   158,     0,     0,     0,     0,
       0,     0,     0,     0,   159,   160,   161,   162,   163,   164,
       0,   165,   166,   167,   153,   154,     0,     0,     0,   274,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,     0,     0,     0,     0,     0,     0,   159,   160,   161,
     162,   163,   164,     0,   165,   166,   167,   153,   154,     0,
       0,     0,   286,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,     0,     0,     0,     0,     0,     0,
     159,   160,   161,   162,   163,   164,     0,   165,   166,   167,
     153,   154,     0,     0,     0,   287,     0,     0,     0,     0,
       0,   155,   156,   157,   158,     0,     0,     0,     0,     0,
       0,     0,     0,   159,   160,   161,   162,   163,   164,     0,
     165,   166,   167,   153,   154,     0,     0,   313,     0,     0,
       0,     0,     0,     0,   155,   156,   157,   158,     0,     0,
       0,     0,     0,     0,     0,     0,   159,   160,   161,   162,
     163,   164,     0,   165,   166,   167,   153,   154,     0,     0,
     314,     0,     0,     0,     0,     0,     0,   155,   156,   157,
     158,     0,     0,     0,     0,     0,     0,     0,     0,   159,
     160,   161,   162,   163,   164,     0,   165,   166,   167,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   156,   157,   158,     0,     0,     0,     0,     0,     0,
       0,     0,   159,   160,   161,   162,   163,   164,     0,   165,
     166,   167,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,     0,
       0,     0,     0,     0,     0,   159,   160,   161,   162,   163,
     164,     0,   165,     0,   167,   153,   154,     0,     0,     0,
       0,     0,     0,   153,   154,     0,   155,   156,   157,   158,
       0,     0,     0,     0,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,     0,   165,   159,   160,   161,   162,
     163,   164,   153,   154,     0,     0,   153,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   158,   155,   156,   157,
     158,     0,     0,     0,     0,   159,     0,   161,   162,   163,
     164,     0,   162,   163,   164
  };

  const short int
  parser::yycheck_[] =
  {
      31,    87,     2,   133,   107,     4,     4,     4,     4,    34,
       5,     4,    98,     4,    46,     4,   213,    70,    62,    49,
      50,    70,     0,    70,    71,     4,    70,    65,    66,    60,
       3,    84,    81,    80,    64,     3,     4,     5,    76,    77,
      78,    79,    68,    33,    70,    70,    35,    47,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    90,    91,
      92,    93,     4,    31,    32,    68,     8,    70,   265,    62,
      61,    75,    69,    69,    69,   107,   108,   180,    82,     4,
      68,    80,   168,    81,   214,    68,    74,    69,    70,     4,
     121,    74,    81,    35,    36,    37,    38,    39,    40,     4,
      42,    43,    44,    45,    46,    69,     4,     4,    69,     4,
      74,   143,    73,    76,    77,    78,    79,    69,    70,   119,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   222,   169,   224,    69,
      70,   173,   174,    69,    70,    74,     4,   179,   180,   181,
     182,   183,   184,   185,   186,     3,     4,     5,     6,     7,
       9,    10,    11,    12,    13,    14,    15,    16,    17,   200,
      18,    19,     3,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    68,   217,    83,    75,     4,
      74,     5,     4,     4,     4,     4,    68,     4,     4,    47,
      48,    49,    50,    69,    68,    70,    68,    68,    71,    57,
      58,    59,    71,    61,    70,    63,    64,    74,    66,    67,
      68,    73,    60,    70,    69,    80,    70,    60,    68,    68,
      62,     5,    78,    68,    71,     4,     4,    71,     3,     4,
       5,     6,     7,   274,   244,    75,    94,   279,     4,     4,
      98,    69,    71,     4,   286,   287,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    69,    69,    20,     5,
      75,   218,   279,    81,   202,   179,   119,   119,   119,   285,
     108,    -1,    47,    48,    49,    50,   278,   307,    -1,    -1,
     119,    -1,    57,    58,    59,   119,    61,   119,    63,    64,
      -1,    66,   119,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    -1,    -1,    98,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    -1,    61,    -1,    63,    64,    -1,    66,
      -1,    68,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    88,    69,    94,    91,    92,
      93,    98,    75,    76,    77,    78,    79,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    -1,    95,    96,    97,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,    95,    96,    97,    65,    66,
      -1,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,    92,    93,    -1,    95,    96,
      97,    65,    66,    -1,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,    93,
      -1,    95,    96,    97,    65,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    90,
      91,    92,    93,    -1,    95,    96,    97,    65,    66,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    92,    93,    -1,    95,    96,    97,
      65,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    90,    91,    92,    93,    -1,
      95,    96,    97,    65,    66,    -1,    -1,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    90,    91,
      92,    93,    -1,    95,    96,    97,    65,    66,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    90,    91,    92,    93,    -1,    95,    96,    97,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    -1,    95,
      96,    97,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    -1,    95,    -1,    97,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    66,    -1,    76,    77,    78,    79,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    88,    89,
      90,    91,    92,    93,    -1,    95,    88,    89,    90,    91,
      92,    93,    65,    66,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    88,    -1,    90,    91,    92,
      93,    -1,    91,    92,    93
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,   101,   102,     0,     4,     8,    35,    36,    37,    38,
      39,    40,    42,    43,    44,    45,    46,   103,   104,   108,
     115,   116,   117,   118,   127,   135,   136,   141,   142,   146,
     147,   148,     3,     4,   109,     4,     4,     4,   137,     4,
       4,     4,    68,    74,    33,   122,    34,    70,    74,    70,
      71,    80,   103,   149,   150,     3,    68,    70,   111,    68,
      75,    82,    83,   138,    75,     3,     4,     5,     6,     7,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      47,    48,    49,    50,    57,    58,    59,    61,    63,    64,
      66,    68,    94,    98,   129,   130,   131,   132,   133,     4,
       5,   123,     4,    18,    19,    31,    32,    67,    68,   119,
     120,   121,   126,   127,   128,   131,   127,   137,   137,   140,
      68,    70,     4,    69,   112,   113,     4,   114,     4,   143,
     144,   145,     4,    61,   103,   105,   106,   107,   110,     4,
       4,   139,   137,    68,     4,   129,     4,   131,   131,   131,
     131,    69,    70,    65,    66,    76,    77,    78,    79,    88,
      89,    90,    91,    92,    93,    95,    96,    97,    68,    68,
     129,    71,    70,    68,    68,   126,   120,   131,    74,    73,
      70,    75,    83,    84,    85,    86,    87,    41,    81,   104,
     108,   115,   116,   135,   141,   147,     4,    69,   151,   103,
      71,    69,    70,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    69,    70,    80,    62,   112,    60,    60,    70,
      84,   131,    68,    62,    68,    69,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   129,   131,    71,    68,   124,     5,   131,   131,
      69,   121,   126,   131,   131,   131,   131,   131,   131,     4,
      75,    69,    70,   103,   113,    71,   145,    81,   112,    62,
     103,     4,   107,     4,    70,   129,   129,    69,    70,    80,
     127,   134,     5,    69,   125,    71,    70,    70,     3,     4,
       5,    31,    32,   152,     4,   145,    81,   103,    69,    69,
     130,   119,    69,    70,   124,   131,   131,    75,    20,    69,
      69,    81,     5,    69,    69,   152
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,   100,   101,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   103,   103,   104,   104,   104,   104,   104,
     104,   104,   105,   105,   106,   106,   107,   107,   108,   109,
     109,   110,   110,   111,   111,   112,   112,   113,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   115,   116,
     116,   117,   118,   118,   119,   120,   120,   121,   121,   122,
     123,   123,   124,   124,   125,   125,   126,   126,   126,   126,
     127,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   129,   129,   130,   130,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   133,
     133,   133,   133,   133,   134,   134,   135,   136,   136,   136,
     137,   138,   138,   139,   139,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   141,   142,   142,   143,   143,   144,
     144,   145,   146,   146,   147,   148,   148,   148,   148,   149,
     149,   149,   150,   150,   151,   151,   152,   152,   152,   152,
     152
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     3,     4,     4,     4,     4,     2,
       2,     2,     1,     3,     1,     3,     3,     4,     4,     1,
       3,     2,     3,     2,     3,     1,     3,     3,     0,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       2,     4,     1,     3,     1,     1,     3,     1,     3,     2,
       3,     5,     2,     3,     1,     3,     1,     1,     3,     2,
       4,     3,     3,     3,     3,     3,     3,     6,     6,     1,
       1,     0,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     2,     3,     6,     5,     4,
       6,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     4,     2,     3,     3,
       2,     0,     3,     1,     3,     0,     2,     2,     2,     3,
       2,     2,     2,     2,     4,     7,     8,     0,     1,     1,
       3,     1,     3,     2,     2,     1,     1,     1,     1,     1,
       3,     4,     1,     3,     3,     5,     1,     1,     1,     1,
       1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\"symbol\"",
  "\"identifier\"", "\"number\"", "\"unsigned number\"", "\"float\"",
  "\"pragma directive\"", "\"relation qualifier output\"",
  "\"relation qualifier input\"", "\"relation qualifier printsize\"",
  "\"BRIE datastructure qualifier\"", "\"BTREE datastructure qualifier\"",
  "\"equivalence relation qualifier\"",
  "\"relation qualifier overidable\"", "\"relation qualifier inline\"",
  "\"relation qualifier magic\"", "\"match predicate\"",
  "\"checks whether substring is contained in a string\"",
  "\"stateful functor\"", "\"concatenation of strings\"",
  "\"ordinal number of a string\"", "\"range\"", "\"length of a string\"",
  "\"sub-string of a string\"", "\"mean aggregator\"",
  "\"min aggregator\"", "\"max aggregator\"", "\"count aggregator\"",
  "\"sum aggregator\"", "\"true literal constraint\"",
  "\"false literal constraint\"", "\"plan keyword\"", "\":-\"",
  "\"relation declaration\"", "\"functor declaration\"",
  "\"input directives declaration\"", "\"output directives declaration\"",
  "\"printsize directives declaration\"",
  "\"limitsize directives declaration\"",
  "\"override rules of super-component\"", "\"type declaration\"",
  "\"component declaration\"", "\"component instantiation\"",
  "\"numeric type declaration\"", "\"symbolic type declaration\"",
  "\"convert to float\"", "\"convert to signed integer\"",
  "\"convert to string\"", "\"convert to unsigned integer\"",
  "\"convert int to unsigned\"", "\"convert int to float\"",
  "\"convert unsigned to int\"", "\"convert unsigned to float\"",
  "\"convert float to int\"", "\"convert float to unsigned\"",
  "\"type cast\"", "\"@\"", "\"nil reference\"", "\"|\"", "\"[\"", "\"]\"",
  "\"_\"", "\"$\"", "\"+\"", "\"-\"", "\"!\"", "\"(\"", "\")\"", "\",\"",
  "\":\"", "\"::\"", "\";\"", "\".\"", "\"=\"", "\"*\"", "\"/\"", "\"^\"",
  "\"%\"", "\"{\"", "\"}\"", "\"<:\"", "\"<\"", "\">\"", "\"<=\"",
  "\">=\"", "\"!=\"", "\"band\"", "\"bor\"", "\"bxor\"", "\"bshl\"",
  "\"bshr\"", "\"bshru\"", "\"bnot\"", "\"land\"", "\"lor\"", "\"lxor\"",
  "\"lnot\"", "NEG", "$accept", "program", "unit", "identifier", "type",
  "union_type_list", "sum_branch_list", "sum_branch", "relation_decl",
  "non_empty_relation_list", "record_type_list", "attributes_list",
  "non_empty_attributes", "attribute", "relation_tags", "fact", "rule",
  "rule_def", "head", "body", "disjunction", "conjunction", "exec_plan",
  "exec_plan_list", "exec_order", "non_empty_exec_order_list", "term",
  "atom", "constraint", "arg_list", "non_empty_arg_list", "arg",
  "functor_built_in", "aggregate_func", "aggregate_body", "component",
  "component_head", "comp_type", "type_params", "type_param_list",
  "component_body", "comp_init", "functor_decl", "functor_arg_type_list",
  "non_empty_functor_arg_type_list", "predefined_type", "pragma",
  "directive_head", "directive_head_decl", "directive_list",
  "relation_directive_list", "non_empty_key_value_pairs", "kvp_value", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  parser::yyrline_[] =
  {
       0,   381,   381,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   408,   410,   419,   420,   421,   422,   424,
     425,   426,   431,   432,   436,   437,   441,   443,   453,   476,
     477,   483,   484,   488,   489,   493,   494,   498,   503,   504,
     506,   508,   510,   511,   512,   513,   514,   515,   523,   527,
     530,   541,   557,   558,   562,   565,   566,   570,   571,   575,
     579,   583,   591,   592,   595,   596,   605,   606,   607,   608,
     612,   617,   618,   619,   620,   621,   622,   625,   627,   631,
     632,   636,   636,   638,   639,   644,   645,   646,   650,   651,
     652,   653,   654,   657,   660,   661,   663,   664,   666,   667,
     670,   696,   706,   707,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   727,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   759,
     760,   761,   762,   763,   767,   768,   777,   788,   789,   790,
     794,   798,   799,   804,   805,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   828,   836,   838,   843,   843,   845,
     846,   851,   872,   873,   878,   888,   889,   890,   891,   896,
     897,   898,   911,   912,   917,   918,   921,   922,   923,   924,
     925
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG



} // yy
#line 2920 "parser/parser.cc" // lalr1.cc:1167
#line 928 "./parser/parser.yy" // lalr1.cc:1168


void yy::parser::error(const location_type &l, const std::string &m) {
    driver.error(l, m);
}
