// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

/**
 ** \file parser/parser.hh
 ** Define the yy::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

#ifndef YY_YY_PARSER_PARSER_HH_INCLUDED
# define YY_YY_PARSER_PARSER_HH_INCLUDED
// //                    "%code requires" blocks.
#line 36 "./parser/parser.yy" // lalr1.cc:377

    #include "AggregateOp.h"
    #include "FunctorOps.h"
    #include "ast/Aggregator.h"
    #include "ast/Argument.h"
    #include "ast/Atom.h"
    #include "ast/Attribute.h"
    #include "ast/BinaryConstraint.h"
    #include "ast/BooleanConstraint.h"
    #include "ast/BranchInit.h"
    #include "ast/Clause.h"
    #include "ast/Component.h"
    #include "ast/ComponentInit.h"
    #include "ast/ComponentType.h"
    #include "ast/Constraint.h"
    #include "ast/Counter.h"
    #include "ast/ExecutionOrder.h"
    #include "ast/ExecutionPlan.h"
    #include "ast/FunctorDeclaration.h"
    #include "ast/Directive.h"
    #include "ast/IntrinsicFunctor.h"
    #include "ast/Literal.h"
    #include "ast/NilConstant.h"
    #include "ast/NumericConstant.h"
    #include "ast/Pragma.h"
    #include "ast/QualifiedName.h"
    #include "ast/RecordInit.h"
    #include "ast/RecordType.h"
    #include "ast/Relation.h"
    #include "ast/StringConstant.h"
    #include "ast/SubsetType.h"
    #include "ast/AlgebraicDataType.h"
    #include "ast/BranchDeclaration.h"
    #include "ast/Type.h"
    #include "ast/TypeCast.h"
    #include "ast/UnionType.h"
    #include "ast/UnnamedVariable.h"
    #include "ast/UserDefinedFunctor.h"
    #include "ast/Variable.h"
    #include "parser/ParserUtils.h"
    #include "souffle/RamTypes.h"
    #include "souffle/BinaryConstraintOps.h"
    #include "souffle/utility/ContainerUtil.h"
    #include "souffle/utility/StringUtil.h"

    using namespace souffle;

    namespace souffle {
        class ParserDriver;

        namespace parser {
          // FIXME: (when we can finally use Bison 3.2) Expunge this abombination.
          // HACK:  Bison 3.0.2 is stupid and ugly and doesn't support move semantics
          //        with the `lalr1.cc` skeleton and that makes me very mad.
          //        Thankfully (or not) two can play stupid games:
          //          Behold! std::auto_ptr 2: The Revengening
          // NOTE:  Bison 3.2 came out in 2019. `std::unique_ptr` appeared in C++11.
          //        How timely.
          // NOTE:  There are specialisations wrappers that'll allow us to (almost)
          //        transparently remove `Mov` once we switch to Bison 3.2+.

          template<typename A>
          struct Mov {
            mutable A value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator A() { return std::move(value); }

            // support ptr-like behaviour
            A* operator->() { return &value; }
            A operator*() { return std::move(value); }
          };

          template<typename A>
          A unwrap(Mov<A> x) { return *x; }

          template<typename A>
          A unwrap(A x) { return x; }

          template<typename A>
          struct Mov<Own<A>> {
            mutable Own<A> value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator Own<A>() { return std::move(value); }
            Own<A> operator*() { return std::move(value); }

            // support ptr-like behaviour
            A* operator->() { return value.get(); }
          };

          template<typename A>
          struct Mov<std::vector<A>> {
            mutable std::vector<A> value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator std::vector<A>() { return std::move(value); }
            auto operator*() {
              std::vector<decltype(unwrap(std::declval<A>()))> ys;
              for (auto&& x : value) ys.push_back(unwrap(std::move(x)));
              return ys;
            }

            // basic ops
            using iterator = typename std::vector<A>::iterator;
            typename std::vector<A>::value_type& operator[](size_t i) { return value[i]; }
            iterator begin() { return value.begin(); }
            iterator end() { return value.end(); }
            void push_back(A x) { value.push_back(std::move(x)); }
            size_t size() const { return value.size(); }
            bool empty() const { return value.empty(); }
          };
        }

        template<typename A>
        parser::Mov<A> clone(const parser::Mov<A>& x) { return clone(x.value); }
    }

    using namespace souffle::parser;

    using yyscan_t = void*;

    #define YY_NULLPTR nullptr

    /* Macro to update locations as parsing proceeds */
    #define YYLLOC_DEFAULT(Cur, Rhs, N)                         \
    do {                                                        \
        if (N) {                                                \
            (Cur).start         = YYRHSLOC(Rhs, 1).start;       \
            (Cur).end           = YYRHSLOC(Rhs, N).end;         \
            (Cur).filenames     = YYRHSLOC(Rhs, N).filenames;   \
        } else {                                                \
            (Cur).start         = YYRHSLOC(Rhs, 0).end;         \
            (Cur).end           = YYRHSLOC(Rhs, 0).end;         \
            (Cur).filenames     = YYRHSLOC(Rhs, 0).filenames;   \
        }                                                       \
    } while (0)

#line 210 "parser/parser.hh" // lalr1.cc:377

# include <cassert>
# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>
# include "stack.hh"

#include <typeinfo>
#ifndef YYASSERT
# include <cassert>
# define YYASSERT assert
#endif


#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif


namespace yy {
#line 287 "parser/parser.hh" // lalr1.cc:377



  /// A char[S] buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current state.
  template <size_t S>
  struct variant
  {
    /// Type of *this.
    typedef variant<S> self_type;

    /// Empty construction.
    variant ()
      : yytypeid_ (YY_NULLPTR)
    {}

    /// Construct and fill.
    template <typename T>
    variant (const T& t)
      : yytypeid_ (&typeid (T))
    {
      YYASSERT (sizeof (T) <= S);
      new (yyas_<T> ()) T (t);
    }

    /// Destruction, allowed only if empty.
    ~variant ()
    {
      YYASSERT (!yytypeid_);
    }

    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    build ()
    {
      YYASSERT (!yytypeid_);
      YYASSERT (sizeof (T) <= S);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T;
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    build (const T& t)
    {
      YYASSERT (!yytypeid_);
      YYASSERT (sizeof (T) <= S);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as ()
    {
      YYASSERT (*yytypeid_ == typeid (T));
      YYASSERT (sizeof (T) <= S);
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const
    {
      YYASSERT (*yytypeid_ == typeid (T));
      YYASSERT (sizeof (T) <= S);
      return *yyas_<T> ();
    }

    /// Swap the content with \a other, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsability.
    /// Swapping between built and (possibly) non-built is done with
    /// variant::move ().
    template <typename T>
    void
    swap (self_type& other)
    {
      YYASSERT (yytypeid_);
      YYASSERT (*yytypeid_ == *other.yytypeid_);
      std::swap (as<T> (), other.as<T> ());
    }

    /// Move the content of \a other to this.
    ///
    /// Destroys \a other.
    template <typename T>
    void
    move (self_type& other)
    {
      build<T> ();
      swap<T> (other);
      other.destroy<T> ();
    }

    /// Copy the content of \a other to this.
    template <typename T>
    void
    copy (const self_type& other)
    {
      build<T> (other.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
      yytypeid_ = YY_NULLPTR;
    }

  private:
    /// Prohibit blind copies.
    self_type& operator=(const self_type&);
    variant (const self_type&);

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ ()
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[S];
    } yybuffer_;

    /// Whether the content is built: if defined, the name of the stored type.
    const std::type_info *yytypeid_;
  };


  /// A Bison parser.
  class parser
  {
  public:
#ifndef YYSTYPE
    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // aggregate_func
      char dummy1[sizeof(AggregateOp)];

      // arg
      char dummy2[sizeof(Mov<Own<ast::Argument>>)];

      // atom
      char dummy3[sizeof(Mov<Own<ast::Atom>>)];

      // attribute
      char dummy4[sizeof(Mov<Own<ast::Attribute>>)];

      // sum_branch
      char dummy5[sizeof(Mov<Own<ast::BranchDeclaration>>)];

      // fact
      char dummy6[sizeof(Mov<Own<ast::Clause>>)];

      // component
      // component_head
      // component_body
      char dummy7[sizeof(Mov<Own<ast::Component>>)];

      // comp_init
      char dummy8[sizeof(Mov<Own<ast::ComponentInit>>)];

      // comp_type
      char dummy9[sizeof(Mov<Own<ast::ComponentType>>)];

      // constraint
      char dummy10[sizeof(Mov<Own<ast::Constraint>>)];

      // exec_order
      char dummy11[sizeof(Mov<Own<ast::ExecutionOrder>>)];

      // exec_plan
      // exec_plan_list
      char dummy12[sizeof(Mov<Own<ast::ExecutionPlan>>)];

      // functor_decl
      char dummy13[sizeof(Mov<Own<ast::FunctorDeclaration>>)];

      // pragma
      char dummy14[sizeof(Mov<Own<ast::Pragma>>)];

      // type
      char dummy15[sizeof(Mov<Own<ast::Type>>)];

      // body
      // disjunction
      // conjunction
      // term
      // aggregate_body
      char dummy16[sizeof(Mov<RuleBody>)];

      // arg_list
      // non_empty_arg_list
      char dummy17[sizeof(Mov<VecOwn<ast::Argument>>)];

      // head
      char dummy18[sizeof(Mov<VecOwn<ast::Atom>>)];

      // record_type_list
      // attributes_list
      // non_empty_attributes
      char dummy19[sizeof(Mov<VecOwn<ast::Attribute>>)];

      // sum_branch_list
      char dummy20[sizeof(Mov<VecOwn<ast::BranchDeclaration>>)];

      // rule
      // rule_def
      char dummy21[sizeof(Mov<VecOwn<ast::Clause>>)];

      // directive_head
      // directive_list
      // relation_directive_list
      char dummy22[sizeof(Mov<VecOwn<ast::Directive>>)];

      // relation_decl
      // non_empty_relation_list
      char dummy23[sizeof(Mov<VecOwn<ast::Relation>>)];

      // non_empty_exec_order_list
      char dummy24[sizeof(Mov<ast::ExecutionOrder::ExecOrder>)];

      // identifier
      char dummy25[sizeof(Mov<ast::QualifiedName>)];

      // functor_built_in
      // kvp_value
      char dummy26[sizeof(Mov<std::string>)];

      // functor_arg_type_list
      // non_empty_functor_arg_type_list
      char dummy27[sizeof(Mov<std::vector<TypeAttribute>>)];

      // union_type_list
      // type_params
      // type_param_list
      char dummy28[sizeof(Mov<std::vector<ast::QualifiedName>>)];

      // non_empty_key_value_pairs
      char dummy29[sizeof(Mov<std::vector<std::pair
            <std::string, std::string>>>)];

      // predefined_type
      char dummy30[sizeof(TypeAttribute)];

      // directive_head_decl
      char dummy31[sizeof(ast::DirectiveType)];

      // relation_tags
      char dummy32[sizeof(std::set<RelationTag>)];

      // "symbol"
      // "identifier"
      // "number"
      // "unsigned number"
      // "float"
      char dummy33[sizeof(std::string)];
};

    /// Symbol semantic values.
    typedef variant<sizeof(union_type)> semantic_type;
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef SrcLocation location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m);
      location_type location;
    };

    /// Tokens.
    struct token
    {
      enum yytokentype
      {
        END = 0,
        STRING = 258,
        IDENT = 259,
        NUMBER = 260,
        UNSIGNED = 261,
        FLOAT = 262,
        PRAGMA = 263,
        OUTPUT_QUALIFIER = 264,
        INPUT_QUALIFIER = 265,
        PRINTSIZE_QUALIFIER = 266,
        BRIE_QUALIFIER = 267,
        BTREE_QUALIFIER = 268,
        EQREL_QUALIFIER = 269,
        OVERRIDABLE_QUALIFIER = 270,
        INLINE_QUALIFIER = 271,
        MAGIC_QUALIFIER = 272,
        TMATCH = 273,
        TCONTAINS = 274,
        STATEFUL = 275,
        CAT = 276,
        ORD = 277,
        RANGE = 278,
        STRLEN = 279,
        SUBSTR = 280,
        MEAN = 281,
        MIN = 282,
        MAX = 283,
        COUNT = 284,
        SUM = 285,
        TRUE = 286,
        FALSE = 287,
        PLAN = 288,
        IF = 289,
        DECL = 290,
        FUNCTOR = 291,
        INPUT_DECL = 292,
        OUTPUT_DECL = 293,
        PRINTSIZE_DECL = 294,
        LIMITSIZE_DECL = 295,
        OVERRIDE = 296,
        TYPE = 297,
        COMPONENT = 298,
        INSTANTIATE = 299,
        NUMBER_TYPE = 300,
        SYMBOL_TYPE = 301,
        TOFLOAT = 302,
        TONUMBER = 303,
        TOSTRING = 304,
        TOUNSIGNED = 305,
        ITOU = 306,
        ITOF = 307,
        UTOI = 308,
        UTOF = 309,
        FTOI = 310,
        FTOU = 311,
        AS = 312,
        AT = 313,
        NIL = 314,
        PIPE = 315,
        LBRACKET = 316,
        RBRACKET = 317,
        UNDERSCORE = 318,
        DOLLAR = 319,
        PLUS = 320,
        MINUS = 321,
        EXCLAMATION = 322,
        LPAREN = 323,
        RPAREN = 324,
        COMMA = 325,
        COLON = 326,
        DOUBLECOLON = 327,
        SEMICOLON = 328,
        DOT = 329,
        EQUALS = 330,
        STAR = 331,
        SLASH = 332,
        CARET = 333,
        PERCENT = 334,
        LBRACE = 335,
        RBRACE = 336,
        SUBTYPE = 337,
        LT = 338,
        GT = 339,
        LE = 340,
        GE = 341,
        NE = 342,
        BW_AND = 343,
        BW_OR = 344,
        BW_XOR = 345,
        BW_SHIFT_L = 346,
        BW_SHIFT_R = 347,
        BW_SHIFT_R_UNSIGNED = 348,
        BW_NOT = 349,
        L_AND = 350,
        L_OR = 351,
        L_XOR = 352,
        L_NOT = 353,
        NEG = 354
      };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Symbol type: an internal symbol number.
    typedef int symbol_number_type;

    /// The symbol type number to denote an empty symbol.
    enum { empty_symbol = -2 };

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef unsigned char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ();

      /// Copy constructor.
      basic_symbol (const basic_symbol& other);

      /// Constructor for valueless symbols, and symbols from each type.

  basic_symbol (typename Base::kind_type t, const location_type& l);

  basic_symbol (typename Base::kind_type t, const AggregateOp v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Argument>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Atom>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Attribute>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::BranchDeclaration>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Clause>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Component>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentInit>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentType>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Constraint>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionOrder>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionPlan>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::FunctorDeclaration>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Pragma>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Type>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<RuleBody> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Argument>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Atom>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Attribute>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::BranchDeclaration>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Clause>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Directive>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Relation>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<ast::ExecutionOrder::ExecOrder> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<ast::QualifiedName> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<std::string> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<std::vector<TypeAttribute>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<std::vector<ast::QualifiedName>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const Mov<std::vector<std::pair
            <std::string, std::string>>> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const TypeAttribute v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const ast::DirectiveType v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::set<RelationTag> v, const location_type& l);

  basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l);


      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    const semantic_type& v,
                    const location_type& l);

      /// Destroy the symbol.
      ~basic_symbol ();

      /// Destroy contents, and record that is empty.
      void clear ();

      /// Whether empty.
      bool empty () const;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& other);
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
      /// Default constructor.
      by_type ();

      /// Copy constructor.
      by_type (const by_type& other);

      /// The symbol type as needed by the constructor.
      typedef token_type kind_type;

      /// Constructor from (external) token numbers.
      by_type (kind_type t);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_type& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_number_type type_get () const;

      /// The token.
      token_type token () const;

      /// The symbol type.
      /// \a empty_symbol when empty.
      /// An int, not token_number_type, to be able to store empty_symbol.
      int type;
    };

    /// "External" symbols: returned by the scanner.
    typedef basic_symbol<by_type> symbol_type;

    // Symbol constructors declarations.
    static inline
    symbol_type
    make_END (const location_type& l);

    static inline
    symbol_type
    make_STRING (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_IDENT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_NUMBER (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_UNSIGNED (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_FLOAT (const std::string& v, const location_type& l);

    static inline
    symbol_type
    make_PRAGMA (const location_type& l);

    static inline
    symbol_type
    make_OUTPUT_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_INPUT_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_PRINTSIZE_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_BRIE_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_BTREE_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_EQREL_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_OVERRIDABLE_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_INLINE_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_MAGIC_QUALIFIER (const location_type& l);

    static inline
    symbol_type
    make_TMATCH (const location_type& l);

    static inline
    symbol_type
    make_TCONTAINS (const location_type& l);

    static inline
    symbol_type
    make_STATEFUL (const location_type& l);

    static inline
    symbol_type
    make_CAT (const location_type& l);

    static inline
    symbol_type
    make_ORD (const location_type& l);

    static inline
    symbol_type
    make_RANGE (const location_type& l);

    static inline
    symbol_type
    make_STRLEN (const location_type& l);

    static inline
    symbol_type
    make_SUBSTR (const location_type& l);

    static inline
    symbol_type
    make_MEAN (const location_type& l);

    static inline
    symbol_type
    make_MIN (const location_type& l);

    static inline
    symbol_type
    make_MAX (const location_type& l);

    static inline
    symbol_type
    make_COUNT (const location_type& l);

    static inline
    symbol_type
    make_SUM (const location_type& l);

    static inline
    symbol_type
    make_TRUE (const location_type& l);

    static inline
    symbol_type
    make_FALSE (const location_type& l);

    static inline
    symbol_type
    make_PLAN (const location_type& l);

    static inline
    symbol_type
    make_IF (const location_type& l);

    static inline
    symbol_type
    make_DECL (const location_type& l);

    static inline
    symbol_type
    make_FUNCTOR (const location_type& l);

    static inline
    symbol_type
    make_INPUT_DECL (const location_type& l);

    static inline
    symbol_type
    make_OUTPUT_DECL (const location_type& l);

    static inline
    symbol_type
    make_PRINTSIZE_DECL (const location_type& l);

    static inline
    symbol_type
    make_LIMITSIZE_DECL (const location_type& l);

    static inline
    symbol_type
    make_OVERRIDE (const location_type& l);

    static inline
    symbol_type
    make_TYPE (const location_type& l);

    static inline
    symbol_type
    make_COMPONENT (const location_type& l);

    static inline
    symbol_type
    make_INSTANTIATE (const location_type& l);

    static inline
    symbol_type
    make_NUMBER_TYPE (const location_type& l);

    static inline
    symbol_type
    make_SYMBOL_TYPE (const location_type& l);

    static inline
    symbol_type
    make_TOFLOAT (const location_type& l);

    static inline
    symbol_type
    make_TONUMBER (const location_type& l);

    static inline
    symbol_type
    make_TOSTRING (const location_type& l);

    static inline
    symbol_type
    make_TOUNSIGNED (const location_type& l);

    static inline
    symbol_type
    make_ITOU (const location_type& l);

    static inline
    symbol_type
    make_ITOF (const location_type& l);

    static inline
    symbol_type
    make_UTOI (const location_type& l);

    static inline
    symbol_type
    make_UTOF (const location_type& l);

    static inline
    symbol_type
    make_FTOI (const location_type& l);

    static inline
    symbol_type
    make_FTOU (const location_type& l);

    static inline
    symbol_type
    make_AS (const location_type& l);

    static inline
    symbol_type
    make_AT (const location_type& l);

    static inline
    symbol_type
    make_NIL (const location_type& l);

    static inline
    symbol_type
    make_PIPE (const location_type& l);

    static inline
    symbol_type
    make_LBRACKET (const location_type& l);

    static inline
    symbol_type
    make_RBRACKET (const location_type& l);

    static inline
    symbol_type
    make_UNDERSCORE (const location_type& l);

    static inline
    symbol_type
    make_DOLLAR (const location_type& l);

    static inline
    symbol_type
    make_PLUS (const location_type& l);

    static inline
    symbol_type
    make_MINUS (const location_type& l);

    static inline
    symbol_type
    make_EXCLAMATION (const location_type& l);

    static inline
    symbol_type
    make_LPAREN (const location_type& l);

    static inline
    symbol_type
    make_RPAREN (const location_type& l);

    static inline
    symbol_type
    make_COMMA (const location_type& l);

    static inline
    symbol_type
    make_COLON (const location_type& l);

    static inline
    symbol_type
    make_DOUBLECOLON (const location_type& l);

    static inline
    symbol_type
    make_SEMICOLON (const location_type& l);

    static inline
    symbol_type
    make_DOT (const location_type& l);

    static inline
    symbol_type
    make_EQUALS (const location_type& l);

    static inline
    symbol_type
    make_STAR (const location_type& l);

    static inline
    symbol_type
    make_SLASH (const location_type& l);

    static inline
    symbol_type
    make_CARET (const location_type& l);

    static inline
    symbol_type
    make_PERCENT (const location_type& l);

    static inline
    symbol_type
    make_LBRACE (const location_type& l);

    static inline
    symbol_type
    make_RBRACE (const location_type& l);

    static inline
    symbol_type
    make_SUBTYPE (const location_type& l);

    static inline
    symbol_type
    make_LT (const location_type& l);

    static inline
    symbol_type
    make_GT (const location_type& l);

    static inline
    symbol_type
    make_LE (const location_type& l);

    static inline
    symbol_type
    make_GE (const location_type& l);

    static inline
    symbol_type
    make_NE (const location_type& l);

    static inline
    symbol_type
    make_BW_AND (const location_type& l);

    static inline
    symbol_type
    make_BW_OR (const location_type& l);

    static inline
    symbol_type
    make_BW_XOR (const location_type& l);

    static inline
    symbol_type
    make_BW_SHIFT_L (const location_type& l);

    static inline
    symbol_type
    make_BW_SHIFT_R (const location_type& l);

    static inline
    symbol_type
    make_BW_SHIFT_R_UNSIGNED (const location_type& l);

    static inline
    symbol_type
    make_BW_NOT (const location_type& l);

    static inline
    symbol_type
    make_L_AND (const location_type& l);

    static inline
    symbol_type
    make_L_OR (const location_type& l);

    static inline
    symbol_type
    make_L_XOR (const location_type& l);

    static inline
    symbol_type
    make_L_NOT (const location_type& l);

    static inline
    symbol_type
    make_NEG (const location_type& l);


    /// Build a parser object.
    parser (ParserDriver &driver_yyarg, yyscan_t yyscanner_yyarg);
    virtual ~parser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

  private:
    /// This class is not copyable.
    parser (const parser&);
    parser& operator= (const parser&);

    /// State numbers.
    typedef int state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yyla      the lookahead token.
    virtual std::string yysyntax_error_ (state_type yystate,
                                         const symbol_type& yyla) const;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short int yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token number \a t to a symbol number.
    static token_number_type yytranslate_ (token_type t);

    // Tables.
  // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
  // STATE-NUM.
  static const short int yypact_[];

  // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
  // Performed when YYTABLE does not specify something else to do.  Zero
  // means the default is an error.
  static const unsigned char yydefact_[];

  // YYPGOTO[NTERM-NUM].
  static const short int yypgoto_[];

  // YYDEFGOTO[NTERM-NUM].
  static const short int yydefgoto_[];

  // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
  // positive, shift that token.  If negative, reduce the rule whose
  // number is the opposite.  If YYTABLE_NINF, syntax error.
  static const short int yytable_[];

  static const short int yycheck_[];

  // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
  // symbol of state STATE-NUM.
  static const unsigned char yystos_[];

  // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
  static const unsigned char yyr1_[];

  // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
  static const unsigned char yyr2_[];


    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *n);


    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#if YYDEBUG
  // YYRLINE[YYN] -- Source line where rule number YYN was defined.
  static const unsigned short int yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    // Debugging.
    int yydebug_;
    std::ostream* yycdebug_;

    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state ();

      /// The symbol type as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s);

      /// Copy constructor.
      by_state (const by_state& other);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol type from \a that.
      void move (by_state& that);

      /// The (internal) type number (corresponding to \a state).
      /// \a empty_symbol when empty.
      symbol_number_type type_get () const;

      /// The state number used to denote an empty symbol.
      enum { empty_state = -1 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, symbol_type& sym);
      /// Assignment, needed by push_back.
      stack_symbol_type& operator= (const stack_symbol_type& that);
    };

    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, stack_symbol_type& s);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, state_type s, symbol_type& sym);

    /// Pop \a n symbols the three stacks.
    void yypop_ (unsigned int n = 1);

    /// Constants.
    enum
    {
      yyeof_ = 0,
      yylast_ = 834,     ///< Last index in yytable_.
      yynnts_ = 53,  ///< Number of nonterminal symbols.
      yyfinal_ = 3, ///< Termination state number.
      yyterror_ = 1,
      yyerrcode_ = 256,
      yyntokens_ = 100  ///< Number of tokens.
    };


    // User arguments.
    ParserDriver &driver;
    yyscan_t yyscanner;
  };

  // Symbol number corresponding to token number t.
  inline
  parser::token_number_type
  parser::yytranslate_ (token_type t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99
    };
    const unsigned int user_token_number_max_ = 354;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

  inline
  parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
      switch (other.type_get ())
    {
      case 133: // aggregate_func
        value.copy< AggregateOp > (other.value);
        break;

      case 131: // arg
        value.copy< Mov<Own<ast::Argument>> > (other.value);
        break;

      case 127: // atom
        value.copy< Mov<Own<ast::Atom>> > (other.value);
        break;

      case 113: // attribute
        value.copy< Mov<Own<ast::Attribute>> > (other.value);
        break;

      case 107: // sum_branch
        value.copy< Mov<Own<ast::BranchDeclaration>> > (other.value);
        break;

      case 115: // fact
        value.copy< Mov<Own<ast::Clause>> > (other.value);
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.copy< Mov<Own<ast::Component>> > (other.value);
        break;

      case 141: // comp_init
        value.copy< Mov<Own<ast::ComponentInit>> > (other.value);
        break;

      case 137: // comp_type
        value.copy< Mov<Own<ast::ComponentType>> > (other.value);
        break;

      case 128: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (other.value);
        break;

      case 124: // exec_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (other.value);
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (other.value);
        break;

      case 142: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (other.value);
        break;

      case 146: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (other.value);
        break;

      case 104: // type
        value.copy< Mov<Own<ast::Type>> > (other.value);
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.copy< Mov<RuleBody> > (other.value);
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (other.value);
        break;

      case 118: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (other.value);
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.copy< Mov<VecOwn<ast::Attribute>> > (other.value);
        break;

      case 106: // sum_branch_list
        value.copy< Mov<VecOwn<ast::BranchDeclaration>> > (other.value);
        break;

      case 116: // rule
      case 117: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (other.value);
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (other.value);
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.copy< Mov<VecOwn<ast::Relation>> > (other.value);
        break;

      case 125: // non_empty_exec_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (other.value);
        break;

      case 103: // identifier
        value.copy< Mov<ast::QualifiedName> > (other.value);
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.copy< Mov<std::string> > (other.value);
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.copy< Mov<std::vector<TypeAttribute>> > (other.value);
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (other.value);
        break;

      case 151: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (other.value);
        break;

      case 145: // predefined_type
        value.copy< TypeAttribute > (other.value);
        break;

      case 148: // directive_head_decl
        value.copy< ast::DirectiveType > (other.value);
        break;

      case 114: // relation_tags
        value.copy< std::set<RelationTag> > (other.value);
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.copy< std::string > (other.value);
        break;

      default:
        break;
    }

  }


  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {
    (void) v;
      switch (this->type_get ())
    {
      case 133: // aggregate_func
        value.copy< AggregateOp > (v);
        break;

      case 131: // arg
        value.copy< Mov<Own<ast::Argument>> > (v);
        break;

      case 127: // atom
        value.copy< Mov<Own<ast::Atom>> > (v);
        break;

      case 113: // attribute
        value.copy< Mov<Own<ast::Attribute>> > (v);
        break;

      case 107: // sum_branch
        value.copy< Mov<Own<ast::BranchDeclaration>> > (v);
        break;

      case 115: // fact
        value.copy< Mov<Own<ast::Clause>> > (v);
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.copy< Mov<Own<ast::Component>> > (v);
        break;

      case 141: // comp_init
        value.copy< Mov<Own<ast::ComponentInit>> > (v);
        break;

      case 137: // comp_type
        value.copy< Mov<Own<ast::ComponentType>> > (v);
        break;

      case 128: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (v);
        break;

      case 124: // exec_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (v);
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (v);
        break;

      case 142: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (v);
        break;

      case 146: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (v);
        break;

      case 104: // type
        value.copy< Mov<Own<ast::Type>> > (v);
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.copy< Mov<RuleBody> > (v);
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (v);
        break;

      case 118: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (v);
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.copy< Mov<VecOwn<ast::Attribute>> > (v);
        break;

      case 106: // sum_branch_list
        value.copy< Mov<VecOwn<ast::BranchDeclaration>> > (v);
        break;

      case 116: // rule
      case 117: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (v);
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (v);
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.copy< Mov<VecOwn<ast::Relation>> > (v);
        break;

      case 125: // non_empty_exec_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (v);
        break;

      case 103: // identifier
        value.copy< Mov<ast::QualifiedName> > (v);
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.copy< Mov<std::string> > (v);
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.copy< Mov<std::vector<TypeAttribute>> > (v);
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (v);
        break;

      case 151: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (v);
        break;

      case 145: // predefined_type
        value.copy< TypeAttribute > (v);
        break;

      case 148: // directive_head_decl
        value.copy< ast::DirectiveType > (v);
        break;

      case 114: // relation_tags
        value.copy< std::set<RelationTag> > (v);
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.copy< std::string > (v);
        break;

      default:
        break;
    }
}


  // Implementation of basic_symbol constructor for each type.

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const AggregateOp v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Argument>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Atom>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Attribute>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::BranchDeclaration>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Clause>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Component>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentInit>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentType>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Constraint>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionOrder>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionPlan>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::FunctorDeclaration>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Pragma>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Type>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<RuleBody> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Argument>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Atom>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Attribute>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::BranchDeclaration>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Clause>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Directive>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Relation>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<ast::ExecutionOrder::ExecOrder> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<ast::QualifiedName> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<std::string> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<std::vector<TypeAttribute>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<std::vector<ast::QualifiedName>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const Mov<std::vector<std::pair
            <std::string, std::string>>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const TypeAttribute v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const ast::DirectiveType v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::set<RelationTag> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  template <typename Base>
  inline
  parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  parser::basic_symbol<Base>::clear ()
  {
    // User destructor.
    symbol_number_type yytype = this->type_get ();
    basic_symbol<Base>& yysym = *this;
    (void) yysym;
    switch (yytype)
    {
   default:
      break;
    }

    // Type destructor.
    switch (yytype)
    {
      case 133: // aggregate_func
        value.template destroy< AggregateOp > ();
        break;

      case 131: // arg
        value.template destroy< Mov<Own<ast::Argument>> > ();
        break;

      case 127: // atom
        value.template destroy< Mov<Own<ast::Atom>> > ();
        break;

      case 113: // attribute
        value.template destroy< Mov<Own<ast::Attribute>> > ();
        break;

      case 107: // sum_branch
        value.template destroy< Mov<Own<ast::BranchDeclaration>> > ();
        break;

      case 115: // fact
        value.template destroy< Mov<Own<ast::Clause>> > ();
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.template destroy< Mov<Own<ast::Component>> > ();
        break;

      case 141: // comp_init
        value.template destroy< Mov<Own<ast::ComponentInit>> > ();
        break;

      case 137: // comp_type
        value.template destroy< Mov<Own<ast::ComponentType>> > ();
        break;

      case 128: // constraint
        value.template destroy< Mov<Own<ast::Constraint>> > ();
        break;

      case 124: // exec_order
        value.template destroy< Mov<Own<ast::ExecutionOrder>> > ();
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.template destroy< Mov<Own<ast::ExecutionPlan>> > ();
        break;

      case 142: // functor_decl
        value.template destroy< Mov<Own<ast::FunctorDeclaration>> > ();
        break;

      case 146: // pragma
        value.template destroy< Mov<Own<ast::Pragma>> > ();
        break;

      case 104: // type
        value.template destroy< Mov<Own<ast::Type>> > ();
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.template destroy< Mov<RuleBody> > ();
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.template destroy< Mov<VecOwn<ast::Argument>> > ();
        break;

      case 118: // head
        value.template destroy< Mov<VecOwn<ast::Atom>> > ();
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.template destroy< Mov<VecOwn<ast::Attribute>> > ();
        break;

      case 106: // sum_branch_list
        value.template destroy< Mov<VecOwn<ast::BranchDeclaration>> > ();
        break;

      case 116: // rule
      case 117: // rule_def
        value.template destroy< Mov<VecOwn<ast::Clause>> > ();
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.template destroy< Mov<VecOwn<ast::Directive>> > ();
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.template destroy< Mov<VecOwn<ast::Relation>> > ();
        break;

      case 125: // non_empty_exec_order_list
        value.template destroy< Mov<ast::ExecutionOrder::ExecOrder> > ();
        break;

      case 103: // identifier
        value.template destroy< Mov<ast::QualifiedName> > ();
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.template destroy< Mov<std::string> > ();
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.template destroy< Mov<std::vector<TypeAttribute>> > ();
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.template destroy< Mov<std::vector<ast::QualifiedName>> > ();
        break;

      case 151: // non_empty_key_value_pairs
        value.template destroy< Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
        break;

      case 145: // predefined_type
        value.template destroy< TypeAttribute > ();
        break;

      case 148: // directive_head_decl
        value.template destroy< ast::DirectiveType > ();
        break;

      case 114: // relation_tags
        value.template destroy< std::set<RelationTag> > ();
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.template destroy< std::string > ();
        break;

      default:
        break;
    }

    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
      switch (this->type_get ())
    {
      case 133: // aggregate_func
        value.move< AggregateOp > (s.value);
        break;

      case 131: // arg
        value.move< Mov<Own<ast::Argument>> > (s.value);
        break;

      case 127: // atom
        value.move< Mov<Own<ast::Atom>> > (s.value);
        break;

      case 113: // attribute
        value.move< Mov<Own<ast::Attribute>> > (s.value);
        break;

      case 107: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (s.value);
        break;

      case 115: // fact
        value.move< Mov<Own<ast::Clause>> > (s.value);
        break;

      case 135: // component
      case 136: // component_head
      case 140: // component_body
        value.move< Mov<Own<ast::Component>> > (s.value);
        break;

      case 141: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (s.value);
        break;

      case 137: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (s.value);
        break;

      case 128: // constraint
        value.move< Mov<Own<ast::Constraint>> > (s.value);
        break;

      case 124: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (s.value);
        break;

      case 122: // exec_plan
      case 123: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (s.value);
        break;

      case 142: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (s.value);
        break;

      case 146: // pragma
        value.move< Mov<Own<ast::Pragma>> > (s.value);
        break;

      case 104: // type
        value.move< Mov<Own<ast::Type>> > (s.value);
        break;

      case 119: // body
      case 120: // disjunction
      case 121: // conjunction
      case 126: // term
      case 134: // aggregate_body
        value.move< Mov<RuleBody> > (s.value);
        break;

      case 129: // arg_list
      case 130: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (s.value);
        break;

      case 118: // head
        value.move< Mov<VecOwn<ast::Atom>> > (s.value);
        break;

      case 110: // record_type_list
      case 111: // attributes_list
      case 112: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (s.value);
        break;

      case 106: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (s.value);
        break;

      case 116: // rule
      case 117: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (s.value);
        break;

      case 147: // directive_head
      case 149: // directive_list
      case 150: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (s.value);
        break;

      case 108: // relation_decl
      case 109: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (s.value);
        break;

      case 125: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (s.value);
        break;

      case 103: // identifier
        value.move< Mov<ast::QualifiedName> > (s.value);
        break;

      case 132: // functor_built_in
      case 152: // kvp_value
        value.move< Mov<std::string> > (s.value);
        break;

      case 143: // functor_arg_type_list
      case 144: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (s.value);
        break;

      case 105: // union_type_list
      case 138: // type_params
      case 139: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (s.value);
        break;

      case 151: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (s.value);
        break;

      case 145: // predefined_type
        value.move< TypeAttribute > (s.value);
        break;

      case 148: // directive_head_decl
        value.move< ast::DirectiveType > (s.value);
        break;

      case 114: // relation_tags
        value.move< std::set<RelationTag> > (s.value);
        break;

      case 3: // "symbol"
      case 4: // "identifier"
      case 5: // "number"
      case 6: // "unsigned number"
      case 7: // "float"
        value.move< std::string > (s.value);
        break;

      default:
        break;
    }

    location = s.location;
  }

  // by_type.
  inline
  parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  parser::by_type::type_get () const
  {
    return type;
  }

  inline
  parser::token_type
  parser::by_type::token () const
  {
    // YYTOKNUM[NUM] -- (External) token number corresponding to the
    // (internal) symbol number NUM (which must be that of a token).  */
    static
    const unsigned short int
    yytoken_number_[] =
    {
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354
    };
    return static_cast<token_type> (yytoken_number_[type]);
  }
  // Implementation of make_symbol for each symbol type.
  parser::symbol_type
  parser::make_END (const location_type& l)
  {
    return symbol_type (token::END, l);
  }

  parser::symbol_type
  parser::make_STRING (const std::string& v, const location_type& l)
  {
    return symbol_type (token::STRING, v, l);
  }

  parser::symbol_type
  parser::make_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::IDENT, v, l);
  }

  parser::symbol_type
  parser::make_NUMBER (const std::string& v, const location_type& l)
  {
    return symbol_type (token::NUMBER, v, l);
  }

  parser::symbol_type
  parser::make_UNSIGNED (const std::string& v, const location_type& l)
  {
    return symbol_type (token::UNSIGNED, v, l);
  }

  parser::symbol_type
  parser::make_FLOAT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::FLOAT, v, l);
  }

  parser::symbol_type
  parser::make_PRAGMA (const location_type& l)
  {
    return symbol_type (token::PRAGMA, l);
  }

  parser::symbol_type
  parser::make_OUTPUT_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::OUTPUT_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_INPUT_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::INPUT_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_PRINTSIZE_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::PRINTSIZE_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_BRIE_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::BRIE_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_BTREE_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::BTREE_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_EQREL_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::EQREL_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_OVERRIDABLE_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::OVERRIDABLE_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_INLINE_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::INLINE_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_MAGIC_QUALIFIER (const location_type& l)
  {
    return symbol_type (token::MAGIC_QUALIFIER, l);
  }

  parser::symbol_type
  parser::make_TMATCH (const location_type& l)
  {
    return symbol_type (token::TMATCH, l);
  }

  parser::symbol_type
  parser::make_TCONTAINS (const location_type& l)
  {
    return symbol_type (token::TCONTAINS, l);
  }

  parser::symbol_type
  parser::make_STATEFUL (const location_type& l)
  {
    return symbol_type (token::STATEFUL, l);
  }

  parser::symbol_type
  parser::make_CAT (const location_type& l)
  {
    return symbol_type (token::CAT, l);
  }

  parser::symbol_type
  parser::make_ORD (const location_type& l)
  {
    return symbol_type (token::ORD, l);
  }

  parser::symbol_type
  parser::make_RANGE (const location_type& l)
  {
    return symbol_type (token::RANGE, l);
  }

  parser::symbol_type
  parser::make_STRLEN (const location_type& l)
  {
    return symbol_type (token::STRLEN, l);
  }

  parser::symbol_type
  parser::make_SUBSTR (const location_type& l)
  {
    return symbol_type (token::SUBSTR, l);
  }

  parser::symbol_type
  parser::make_MEAN (const location_type& l)
  {
    return symbol_type (token::MEAN, l);
  }

  parser::symbol_type
  parser::make_MIN (const location_type& l)
  {
    return symbol_type (token::MIN, l);
  }

  parser::symbol_type
  parser::make_MAX (const location_type& l)
  {
    return symbol_type (token::MAX, l);
  }

  parser::symbol_type
  parser::make_COUNT (const location_type& l)
  {
    return symbol_type (token::COUNT, l);
  }

  parser::symbol_type
  parser::make_SUM (const location_type& l)
  {
    return symbol_type (token::SUM, l);
  }

  parser::symbol_type
  parser::make_TRUE (const location_type& l)
  {
    return symbol_type (token::TRUE, l);
  }

  parser::symbol_type
  parser::make_FALSE (const location_type& l)
  {
    return symbol_type (token::FALSE, l);
  }

  parser::symbol_type
  parser::make_PLAN (const location_type& l)
  {
    return symbol_type (token::PLAN, l);
  }

  parser::symbol_type
  parser::make_IF (const location_type& l)
  {
    return symbol_type (token::IF, l);
  }

  parser::symbol_type
  parser::make_DECL (const location_type& l)
  {
    return symbol_type (token::DECL, l);
  }

  parser::symbol_type
  parser::make_FUNCTOR (const location_type& l)
  {
    return symbol_type (token::FUNCTOR, l);
  }

  parser::symbol_type
  parser::make_INPUT_DECL (const location_type& l)
  {
    return symbol_type (token::INPUT_DECL, l);
  }

  parser::symbol_type
  parser::make_OUTPUT_DECL (const location_type& l)
  {
    return symbol_type (token::OUTPUT_DECL, l);
  }

  parser::symbol_type
  parser::make_PRINTSIZE_DECL (const location_type& l)
  {
    return symbol_type (token::PRINTSIZE_DECL, l);
  }

  parser::symbol_type
  parser::make_LIMITSIZE_DECL (const location_type& l)
  {
    return symbol_type (token::LIMITSIZE_DECL, l);
  }

  parser::symbol_type
  parser::make_OVERRIDE (const location_type& l)
  {
    return symbol_type (token::OVERRIDE, l);
  }

  parser::symbol_type
  parser::make_TYPE (const location_type& l)
  {
    return symbol_type (token::TYPE, l);
  }

  parser::symbol_type
  parser::make_COMPONENT (const location_type& l)
  {
    return symbol_type (token::COMPONENT, l);
  }

  parser::symbol_type
  parser::make_INSTANTIATE (const location_type& l)
  {
    return symbol_type (token::INSTANTIATE, l);
  }

  parser::symbol_type
  parser::make_NUMBER_TYPE (const location_type& l)
  {
    return symbol_type (token::NUMBER_TYPE, l);
  }

  parser::symbol_type
  parser::make_SYMBOL_TYPE (const location_type& l)
  {
    return symbol_type (token::SYMBOL_TYPE, l);
  }

  parser::symbol_type
  parser::make_TOFLOAT (const location_type& l)
  {
    return symbol_type (token::TOFLOAT, l);
  }

  parser::symbol_type
  parser::make_TONUMBER (const location_type& l)
  {
    return symbol_type (token::TONUMBER, l);
  }

  parser::symbol_type
  parser::make_TOSTRING (const location_type& l)
  {
    return symbol_type (token::TOSTRING, l);
  }

  parser::symbol_type
  parser::make_TOUNSIGNED (const location_type& l)
  {
    return symbol_type (token::TOUNSIGNED, l);
  }

  parser::symbol_type
  parser::make_ITOU (const location_type& l)
  {
    return symbol_type (token::ITOU, l);
  }

  parser::symbol_type
  parser::make_ITOF (const location_type& l)
  {
    return symbol_type (token::ITOF, l);
  }

  parser::symbol_type
  parser::make_UTOI (const location_type& l)
  {
    return symbol_type (token::UTOI, l);
  }

  parser::symbol_type
  parser::make_UTOF (const location_type& l)
  {
    return symbol_type (token::UTOF, l);
  }

  parser::symbol_type
  parser::make_FTOI (const location_type& l)
  {
    return symbol_type (token::FTOI, l);
  }

  parser::symbol_type
  parser::make_FTOU (const location_type& l)
  {
    return symbol_type (token::FTOU, l);
  }

  parser::symbol_type
  parser::make_AS (const location_type& l)
  {
    return symbol_type (token::AS, l);
  }

  parser::symbol_type
  parser::make_AT (const location_type& l)
  {
    return symbol_type (token::AT, l);
  }

  parser::symbol_type
  parser::make_NIL (const location_type& l)
  {
    return symbol_type (token::NIL, l);
  }

  parser::symbol_type
  parser::make_PIPE (const location_type& l)
  {
    return symbol_type (token::PIPE, l);
  }

  parser::symbol_type
  parser::make_LBRACKET (const location_type& l)
  {
    return symbol_type (token::LBRACKET, l);
  }

  parser::symbol_type
  parser::make_RBRACKET (const location_type& l)
  {
    return symbol_type (token::RBRACKET, l);
  }

  parser::symbol_type
  parser::make_UNDERSCORE (const location_type& l)
  {
    return symbol_type (token::UNDERSCORE, l);
  }

  parser::symbol_type
  parser::make_DOLLAR (const location_type& l)
  {
    return symbol_type (token::DOLLAR, l);
  }

  parser::symbol_type
  parser::make_PLUS (const location_type& l)
  {
    return symbol_type (token::PLUS, l);
  }

  parser::symbol_type
  parser::make_MINUS (const location_type& l)
  {
    return symbol_type (token::MINUS, l);
  }

  parser::symbol_type
  parser::make_EXCLAMATION (const location_type& l)
  {
    return symbol_type (token::EXCLAMATION, l);
  }

  parser::symbol_type
  parser::make_LPAREN (const location_type& l)
  {
    return symbol_type (token::LPAREN, l);
  }

  parser::symbol_type
  parser::make_RPAREN (const location_type& l)
  {
    return symbol_type (token::RPAREN, l);
  }

  parser::symbol_type
  parser::make_COMMA (const location_type& l)
  {
    return symbol_type (token::COMMA, l);
  }

  parser::symbol_type
  parser::make_COLON (const location_type& l)
  {
    return symbol_type (token::COLON, l);
  }

  parser::symbol_type
  parser::make_DOUBLECOLON (const location_type& l)
  {
    return symbol_type (token::DOUBLECOLON, l);
  }

  parser::symbol_type
  parser::make_SEMICOLON (const location_type& l)
  {
    return symbol_type (token::SEMICOLON, l);
  }

  parser::symbol_type
  parser::make_DOT (const location_type& l)
  {
    return symbol_type (token::DOT, l);
  }

  parser::symbol_type
  parser::make_EQUALS (const location_type& l)
  {
    return symbol_type (token::EQUALS, l);
  }

  parser::symbol_type
  parser::make_STAR (const location_type& l)
  {
    return symbol_type (token::STAR, l);
  }

  parser::symbol_type
  parser::make_SLASH (const location_type& l)
  {
    return symbol_type (token::SLASH, l);
  }

  parser::symbol_type
  parser::make_CARET (const location_type& l)
  {
    return symbol_type (token::CARET, l);
  }

  parser::symbol_type
  parser::make_PERCENT (const location_type& l)
  {
    return symbol_type (token::PERCENT, l);
  }

  parser::symbol_type
  parser::make_LBRACE (const location_type& l)
  {
    return symbol_type (token::LBRACE, l);
  }

  parser::symbol_type
  parser::make_RBRACE (const location_type& l)
  {
    return symbol_type (token::RBRACE, l);
  }

  parser::symbol_type
  parser::make_SUBTYPE (const location_type& l)
  {
    return symbol_type (token::SUBTYPE, l);
  }

  parser::symbol_type
  parser::make_LT (const location_type& l)
  {
    return symbol_type (token::LT, l);
  }

  parser::symbol_type
  parser::make_GT (const location_type& l)
  {
    return symbol_type (token::GT, l);
  }

  parser::symbol_type
  parser::make_LE (const location_type& l)
  {
    return symbol_type (token::LE, l);
  }

  parser::symbol_type
  parser::make_GE (const location_type& l)
  {
    return symbol_type (token::GE, l);
  }

  parser::symbol_type
  parser::make_NE (const location_type& l)
  {
    return symbol_type (token::NE, l);
  }

  parser::symbol_type
  parser::make_BW_AND (const location_type& l)
  {
    return symbol_type (token::BW_AND, l);
  }

  parser::symbol_type
  parser::make_BW_OR (const location_type& l)
  {
    return symbol_type (token::BW_OR, l);
  }

  parser::symbol_type
  parser::make_BW_XOR (const location_type& l)
  {
    return symbol_type (token::BW_XOR, l);
  }

  parser::symbol_type
  parser::make_BW_SHIFT_L (const location_type& l)
  {
    return symbol_type (token::BW_SHIFT_L, l);
  }

  parser::symbol_type
  parser::make_BW_SHIFT_R (const location_type& l)
  {
    return symbol_type (token::BW_SHIFT_R, l);
  }

  parser::symbol_type
  parser::make_BW_SHIFT_R_UNSIGNED (const location_type& l)
  {
    return symbol_type (token::BW_SHIFT_R_UNSIGNED, l);
  }

  parser::symbol_type
  parser::make_BW_NOT (const location_type& l)
  {
    return symbol_type (token::BW_NOT, l);
  }

  parser::symbol_type
  parser::make_L_AND (const location_type& l)
  {
    return symbol_type (token::L_AND, l);
  }

  parser::symbol_type
  parser::make_L_OR (const location_type& l)
  {
    return symbol_type (token::L_OR, l);
  }

  parser::symbol_type
  parser::make_L_XOR (const location_type& l)
  {
    return symbol_type (token::L_XOR, l);
  }

  parser::symbol_type
  parser::make_L_NOT (const location_type& l)
  {
    return symbol_type (token::L_NOT, l);
  }

  parser::symbol_type
  parser::make_NEG (const location_type& l)
  {
    return symbol_type (token::NEG, l);
  }



} // yy
#line 3149 "parser/parser.hh" // lalr1.cc:377




#endif // !YY_YY_PARSER_PARSER_HH_INCLUDED
